<?php

// Q-registerations 2.5 build:20110627

// domid is replaced by parentid (see aQTcontainer)
// topics is replaced by items (see aQTcontainer)

class cSection extends aQTcontainer implements IOptions,IStats
{

public $domname='';     // Domain name
public $idtitle='untitled';// Section idtitle
public $name='untitled';// Section name (translation)
public $descr='';       // Section descr (translation)
public $notify=1;       // Notify: 0=disable, 1=enabled
public $modid=0;        // Moderator id
public $modname='Admin';// Moderaotr name
public $numfield='%03s';// Format of the ref number: 'N' means no ref number
public $titlefield=1;   // Topic title: 0=None, 1=Optional, 2=Mandatory
public $eventdate=0;    // Topic eventdate: 0=None, 1=Optional, 2=Mandatory, 3=Date+time (optional), 4=Date+time (mandatory)
public $wisheddate=0;   // Topic wisheddate: 0=None, 1=Optional, 2=Mandatory
public $wisheddflt=0;   // Topic wisheddate [2] default: 0=None, 1=Today, 2=Day+1, 3=Day+2
public $notifycc=0;     // Topic alternate notify: 0=None, 1=Optional, 2=Mandatory
public $prefix='a';     // Prefix icon from the serie 'a'

public $stats='';    // Several stats
public $options='';  // Several options

// stats
public $tabs=3;      // Total tabs (including the 3 basic)
public $replies=0;   // Total replies (type R,F or  D)
public $tags=0;      // >0 means tags exists (may be several time the same!)
public $topicsZ=0;   // Total topics closed (including news)
public $repliesZ=0;  // Total replies in topics closed (type R,F or  D)

// options
public $d_order='';       // Ticket default sort order
public $d_last='replies'; // Last column in the topic list: '0' means no last column
public $d_logo='';        // Ovewrite icon with an image-logo named s_x.gif/.jpeg/.jpg/.png (where x is the section id)

// computed values
public $lastpostid=-1;
public $lastposttopic=-1;
public $lastpostdate='0';
public $lastpostuser=0;
public $lastpostname='Visitor';

// --------

function __construct($aSection=null,$bLast=false)
{
  if ( isset($aSection) )
  {
    if ( is_int($aSection) )
    {
      if ( $aSection<0 ) die('No section '.$aSection);      
      global $oDB;      
      $oDB->Query( 'SELECT * FROM '.TABSECTION.' WHERE id='.$aSection );
      $row = $oDB->Getrow();
      if ( $row===False ) die('No section '.$aSection);
      $this->MakeFromArray($row);
    }
    elseif ( is_array($aSection) )
    {
      $this->MakeFromArray($aSection);
    }
    else
    {
      die('Invalid constructor parameter #1 for the class cSection');
    }
  }

  // Read options
  
  $this->ReadOptions();
  $this->ReadStats();
    
  // Find last post
  
  if ( $bLast ) $this->GetSectionLastPost();
  
  // Default sort order
  
  if ( empty($this->d_order) ) $this->d_order='lastpostdate';
  if ( $this->d_last=='wisheddate' && $this->wisheddate==0 ) $this->d_last='none';
  if ( $this->d_last=='notifiedname' && $this->notifycc==0 ) $this->d_last='none';
  if ( $this->d_last=='no' || empty($this->d_last) ) $this->d_last='none';

}

// --------

private function MakeFromArray($aSection)
{
  foreach($aSection as $strKey=>$oValue) {
  switch ($strKey) {
    case 'domainid':     $this->parentid     = intval($oValue); break;
    case 'id':           $this->id        = intval($oValue); break;
    case 'title':        $this->idtitle   = $oValue; break;
    case 'type':         $this->type      = intval($oValue); break;
    case 'status':       $this->status    = intval($oValue); break;
    case 'notify':       $this->notify    = intval($oValue); break;
    case 'moderator':    $this->modid     = intval($oValue); break;
    case 'moderatorname':$this->modname   = $oValue; break;
    case 'stats':        $this->stats     = $oValue; break;
    case 'options':      $this->options   = $oValue; break;
    case 'numfield':     $this->numfield  = $oValue; break;
    case 'titlefield':   $this->titlefield= intval($oValue); break;
    case 'eventdate':    $this->eventdate = intval($oValue); break;
    case 'wisheddate':
      $this->wisheddate = intval($oValue);
      if ( $this->wisheddate>2 ) { $this->wisheddflt=$this->wisheddate-2; $this->wisheddate=2;  }
    break;
    case 'alternate':    $this->notifycc  = intval($oValue); break;
    case 'prefix':       $this->prefix    = $oValue; break;
  }}
  $this->name = ObjTrans('sec','s'.$this->id,$this->idtitle);
  $this->descr = ObjTrans('secdesc','s'.$this->id,false);
  $this->domname= ObjTrans('domain','d'.$this->parentid,'(domain '.$this->parentid.')');
}

// --------

function GetSectionLastPost()
{  
  // Initialize & check
  
  $this->lastpostid = null;
  $this->lastposttopic = null;
  $this->lastpostdate = null;
  $this->lastpostuser = null;
  $this->lastpostname = null;
  if ( $this->id<0 ) return null;
  if ( $this->items==0 ) return null;
  
  // Query
  
  global $oDB;
  $oDB->Query( 'SELECT id,topic,issuedate,userid,username FROM '.TABPOST.' WHERE id=(SELECT MAX(id) as maxid FROM '.TABPOST.' WHERE section='.$this->id.')' );
  if ( $row=$oDB->Getrow() )
  {
  $this->lastpostid = intval($row['id']);
  $this->lastposttopic = intval($row['topic']);
  $this->lastpostdate = $row['issuedate'];
  $this->lastpostuser = intval($row['userid']);
  $this->lastpostname = $row['username'];
  }
}

// --------

function GetLogo()
{
  if ( !empty($this->d_logo) )
  {
  if ( file_exists('upload/section/'.$this->d_logo) ) return 'upload/section/'.$this->d_logo;
  }
  return $_SESSION[QT]['skin_dir'].'/ico_section_'.$this->type.'_'.$this->status.'.gif';
}

// --------

function GetTagsUsed($intS=null,$intMax=50)
{
  // -1 to compute on all sections // maximum returned is $intMax distinct tags
  // Allow instanciation
  
  if ( !isset($intS) ) $intS = $this->id;

  // Check

  if ( !is_int($intS) ) die('cSection->GetTagsUsed: Argument #1 must be integer');

  // Process

  $arrTags = array();  
  global $oDB;
  $oDB->Query( 'SELECT DISTINCT tags FROM '.TABTOPIC.($intS==-1 ? '' : ' WHERE section='.$intS) ); //' WHERE section='.$intS );
  $i=0;
  while($row=$oDB->Getrow()) {
  if ( !empty($row['tags']) ) {

    $arr = explode(';',$row['tags']);
    foreach($arr as $str)
    {
      if ( !empty($str) ) {
      if ( !in_array($str,$arrTags) ) {
        $arrTags[$str] = $str;
        $i++;
        if ( $i>$intMax ) break;      
      }}
    }    
    if ( $i>$intMax ) break;
    
  }}
  if ( count($arrTags)>2 ) asort($arrTags);
  return $arrTags;
}

// --------

function DeleteTopics($bClosedOnly=false,$strYear='',$bUpdateStats=true)
{
  if ( $this->id<0 ) die('cSection->DeleteTopics: Wrong argument #1 (id<0)');
  if ( !is_string($strYear) ) $strYear = intval($strYear); // $strYear can be a integer or the string 'old'
  if ( strlen($strYear)>4 ) die('cSection->DeleteTopics: Argument #2 must be a string');

  // Process - delete topics and posts
  
  global $oDB;

  $strWhere = (empty($strYear) ? '' : ' AND '.SqlDateCondition($strYear));
  
  if ( $bClosedOnly )
  {
    $arr = array();
    $oDB->Query( 'SELECT id FROM '.TABTOPIC.' WHERE section='.$this->id.' AND status="Z" AND type="T"'.$strWhere );
    while($row=$oDB->Getrow())
    {
      $arr[] = $row['id'];
    }
    foreach($arr as $intKey=>$id)
    {
      $oDB->Query( 'DELETE FROM '.TABPOST.' WHERE topic='.$id );
      $oDB->Query( 'DELETE FROM '.TABDATA.' WHERE id='.$id );
      $oDB->Query( 'DELETE FROM '.TABTOPIC.' WHERE id='.$id );
    }
  }
  else
  {
    $oDB->Query( 'DELETE FROM '.TABPOST.' WHERE section='.$this->id.str_replace('firstpostdate','issuedate',$strWhere) );
    $oDB->Query( 'DELETE FROM '.TABDATA.' WHERE id IN (SELECT id FROM '.TABTOPIC.' WHERE section='.$this->id.$strWhere.')' );
    $oDB->Query( 'DELETE FROM '.TABTOPIC.' WHERE section='.$this->id.$strWhere );
  }

  // Update section stats
  
  if ( $bUpdateStats ) UpdateSectionStats($this->id,array('tabs'=>$this->tabs,'tags'=>$this->tags));

  // Impact on globals

  if ( isset($_SESSION[QT]['sys_topics']) ) Unset($_SESSION[QT]['sys_topics']);
  if ( isset($_SESSION[QT]['sys_replies']) ) Unset($_SESSION[QT]['sys_replies']);
}

// --------

public static function UpdateLastPostDate($id)
{
  global $oDB;
  if ( in_array($oDB->type,array('sqlite','mssql','pg','sqlsrv','db2')) )
  {
  $oDB->Query( 'UPDATE '.TABTOPIC.' SET lastpostdate=(SELECT MAX(issuedate) FROM '.TABPOST.' p, '.TABTOPIC.' t WHERE t.id=p.topic) WHERE section='.$id );
  }
  else
  {
  $oDB->Query( 'UPDATE '.TABTOPIC.' t SET t.lastpostdate=(SELECT MAX(p.issuedate) FROM '.TABPOST.' p WHERE t.id=p.topic) WHERE t.section='.$id );
  }
}
public static function UpdateReplies()
{
  global $oDB;
  if ( in_array($oDB->type,array('sqlite','mssql','pg','sqlsrv','db2')) )
  {
  $oDB->Query( 'UPDATE '.TABTOPIC.' SET replies=(SELECT COUNT(*) FROM '.TABPOST.' p, '.TABTOPIC.' t WHERE t.id=p.topic) WHERE section='.$id );
  }
  else
  {
  $oDB->Query( 'UPDATE '.TABTOPIC.' t SET t.replies=(SELECT COUNT(p.id) FROM '.TABPOST.' p WHERE t.id=p.topic AND p.type<>"P") WHERE t.section='.$id );
  }
}

// --------

public function UpdateStats($arrValues=array(),$bLastPostDate=false,$bReplies=false)
{
  if ( $this->id<0 ) die('UpdateSectionStats: Wrong id');

  // Process (provided values are not recomputed)
  
  if ( !isset($arrValues['topics']) )   $arrValues['topics']  = cSection::CountItems($this->id,'topics');
  if ( !isset($arrValues['replies']) )  $arrValues['replies'] = cSection::CountItems($this->id,'replies');
  if ( !isset($arrValues['tabs']) )     $arrValues['tabs']    = cSection::CountItems($this->id,'tabs');
  if ( !isset($arrValues['tags']) )     $arrValues['tags']    = cSection::CountItems($this->id,'tags');
  if ( !isset($arrValues['topicsZ']) )  $arrValues['topicsZ'] = cSection::CountItems($this->id,'topicsZ');
  if ( !isset($arrValues['repliesZ']) ) $arrValues['repliesZ']= cSection::CountItems($this->id,'repliesZ');
  
  $this->stats = QTimplode($arrValues);
  $this->WriteStats();
  if ( $bLastPostDate ) cSection::UpdateLastPostDate($this->id); // used after import
  if ( $bReplies ) cSection::UpdateReplies($this->id);  // used after import
}

// --------
// aQTcontainer implementations
// --------

public static function Create($title,$parentid)
{
  QTargs( 'cSection->Create',array($title,$parentid),array('str','int') );
  if ( empty($title) ) die('cSection->Create: Argument #1 must be a string');
  global $oDB;
  $id = $oDB->Nextid(TABSECTION);
  $oDB->Query( 'INSERT INTO '.TABSECTION.' (domainid,id,type,status,notify,titleorder,moderator,titlefield,eventdate,wisheddate,alternate,title,stats,options,moderatorname,numfield,prefix) VALUES ('.$parentid.','.$id.',0,0,1,0,0,1,0,0,0,"'.addslashes($title).'","","order=0;last=0;logo=0","Admin","%03s","a")' );
  $oDB->Query( 'INSERT INTO '.TABTAB.' (section,tabid,taborder,tabselect,tabframe,tabfields) VALUES ('.$id.',"ticket",0,"1","",0)' );
  $oDB->Query( 'INSERT INTO '.TABTAB.' (section,tabid,taborder,tabselect,tabframe,tabfields) VALUES ('.$id.',"messages",253,"1","",0)' );
  $oDB->Query( 'INSERT INTO '.TABTAB.' (section,tabid,taborder,tabselect,tabframe,tabfields) VALUES ('.$id.',"documents",254,"1","",0)' );
  // Impact on globals
  if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
  return $id;
}

public static function Drop($id)
{
  if ( $id<1 ) die('cSection->Drop: Cannot delete section 0');
  global $oDB;
  $oDB->Query( 'DELETE FROM '.TABPOST.' WHERE topic='.$id );
  $oDB->Query( 'DELETE FROM '.TABDATA.' WHERE id='.$id );
  $oDB->Query( 'DELETE FROM '.TABTOPIC.' WHERE id='.$id );
  $oDB->Query( 'DELETE FROM '.TABSECTION.' WHERE id='.$id );
  $oDB->Query( 'DELETE FROM '.TABTAB.' WHERE section='.$id );
  cVIP::LangDel(array('sec','secdesc'),'s'.$id);
  // Impact on globals
  if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
}

public static function MoveItems($id,$destination,$intRenum=1,$intTopic=-1,$bClosedOnly=false,$strYear='')
{
  if ( !is_int($id) ) die('cSection->MoveItems: Argument #1 must be integer');
  if ( !is_int($destination) ) die('cSection->MoveItems: Argument #2 must be integer');
  if ( $id<0 ) die('cSection->MoveItems: Wrong argument #1 (id<0)');
  if ( $destination<0 ) die('cSection->MoveItems: Wrong argument #2 (d<1)');
  if ( $id==$destination ) die('cSection->MoveItems: Wrong argument, source=destination');
  if ( !is_string($strYear) ) $strYear = intval($strYear); // $strYear can be a integer or "old"
  if ( strlen($strYear)>4 ) die('cSection->MoveItems: Argument #2 must be a string');

  global $oDB;

  $strWhere = (empty($strYear) ? '' : ' AND '.SqlDateCondition($strYear));
  $strTopic = '';
  $strPost = '';
  $strField = ''; if ( $intRenum==0 ) $strField = ', numid = 0';

  // Move only one topic

  if ( $intTopic>=0 )
  {
    $strTopic=" AND id=$intTopic";
    $strPost=" AND topic=$intTopic";
    if ( $intRenum==2 )
    {
    $nextnumid = $oDB->Nextid(TABTOPIC,'numid','WHERE section='.$destination);
    $strField = ', numid='.intval($nextnumid);
    }
    $bClosedOnly=false;
  }
  else
  {
    if ( $intRenum==2 )
    {
    $nextnumid = $oDB->Nextid(TABTOPIC,'numid','WHERE section='.$destination);
    $oDB->Query('SELECT MIN(numid) as minnumid FROM '.TABTOPIC.' WHERE section='.$id);
    $row = $oDB->Getrow();
    $minnumid = $row['minnumid'];
    $strField = ", numid = $nextnumid + (numid - $minnumid)";
    }
  }

  // Check if prefix system are the same. If not, remove the prefix.

  $strSetPrefix = '';
  if ( !empty($this->prefix) )
  {
    $oDB->Query('SELECT prefix FROM '.TABSECTION.' WHERE id='.$destination);
    $row = $oDB->Getrow();
    if ( $row['prefix']!=$this->prefix ) $strSetPrefix = ',icon="00"';
  }

  // Update topics and posts

  if ( $bClosedOnly )
  {
    $arr = array();
    $oDB->Query('SELECT id FROM '.TABTOPIC.' WHERE section='.$id.' AND status="Z" AND type="T"'.$strWhere);
    while($row=$oDB->Getrow()) $arr[] = $row['id'];
    foreach($arr as $intVal)
    {
    $oDB->Query( 'UPDATE '.TABTOPIC.' SET section='.$destination.$strField.',modifdate="'.date('Ymd His').'" WHERE id='.$intVal );
    $oDB->Query( 'UPDATE '.TABPOST.' SET section='.$destination.$strSetPrefix.' WHERE topic='.$intVal );
    }
  }
  else
  {
    $oDB->Query( 'UPDATE '.TABTOPIC.' SET section='.$destination.$strField.',modifdate="'.date('Ymd His').'" WHERE section='.$id.' '.$strTopic );
    $oDB->Query( 'UPDATE '.TABPOST.' SET section='.$destination.$strSetPrefix.' WHERE section='.$id.' '.$strPost );
  }
}

public static function CountItems($id,$status,$intD=10,$strYear='')
{
  if ( !is_int($intD) ) die('cSection->Count: Argument #2 must be an int');
  if ( $id<0 ) die('cSection->Count: Wrong argument (id<0)');
  if ( $intD<1 ) die('cSection->Count: Wrong argument #2 (d<1)');
  if ( !is_string($strYear) ) $strYear = intval($strYear); // $strYear can be a integer or "old"
  if ( strlen($strYear)>4 ) die('cSection->Count: Argument #3 must be a string');

  global $oDB;
  
  $strWhere = (empty($strYear) ? '' : ' AND '.SqlDateCondition($strYear));
  
  // Process

  switch($status)
  {
  case 'topics': $oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' WHERE section='.$id.$strWhere ); break;
  case 'topicsZ': $oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' WHERE status="Z" AND section='.$id.$strWhere ); break;
  case 'news': $oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' WHERE section='.$id.' AND type="A"'.$strWhere ); break;
  case 'inspections': $oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' WHERE section='.$id.' AND type="I"'.$strWhere ); break;
  case 'replies': $oDB->Query( 'SELECT count(*) as countid FROM '.TABPOST.' WHERE section='.$id.' AND (type="R" OR type="F")'.str_replace('firstpostdate','issuedate',$strWhere) ); break;
  case 'repliesZ': $oDB->Query( 'SELECT count(*) as countid FROM '.TABPOST.' p INNER JOIN '.TABTOPIC.' t ON p.topic=t.id WHERE p.section='.$id.' AND p.type<>"P" AND t.status="Z"'.$strWhere ); break;
  case 'unreplied': $oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' WHERE section='.$id.' AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$intD,'day').'"'.$strWhere ); break;
  case 'unrepliedT': $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE section='.$id.' AND type="T" AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$intD,'day').'"'.$strWhere ); break;
  case 'unrepliedA': $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE section='.$id.' AND type="A" AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$intD,'day').'"'.$strWhere ); break;
  case 'unrepliedI': $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE section='.$id.' AND type="I" AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$intD,'day').'"'.$strWhere ); break;
  case 'tags': $oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' WHERE tags<>"" AND section='.$id.$strWhere ); break;
  case 'tabs': $oDB->Query( 'SELECT count(*) as countid FROM '.TABTAB.' WHERE section='.$id ); break;
  case 'messages': $oDB->Query( 'SELECT count(*) as countid FROM '.TABPOST.' WHERE section='.$id.$strWhere ); break;
  case 'unrepliednews': $oDB->Query( 'SELECT count(id) as countid FROM '.TABTOPIC.' WHERE section='.$id.' AND type="A" AND replies=0 AND firstpostdate<"'.DateAdd(date('Ymd His'),-$intD,'day').'"'.$strWhere ); break; // (unrepliedA) stays for backbward compatibility
  default: die('cSection->Count: Wrong argument #1 '.$status);
  }
  $row = $oDB->Getrow();
  return intval($row['countid']);
}

// --------
// IOptions, IStats implementations
// --------

public function ChangeOption($strKey,$strValue)
{
  QTargs('cSection->ChangeOption',array($strKey,$strValue));
  if ( $strKey==='' ) die ('cSection->ChangeOption: Missing key'); // $strKey can be ''

  $arr = QTarradd(QTexplode($this->options),$strKey,$strValue);
  $this->options = QTimplode($arr);
  $this->WriteOptions();
  return $arr;
}

public function ReadOptions()
{
  $arr = QTexplode($this->options);
  if ( isset($arr['order']) ) $this->d_order = $arr['order'];
  if ( isset($arr['last']) ) $this->d_last = $arr['last'];
  if ( isset($arr['logo']) ) $this->d_logo = $arr['logo']; 
  return $arr;
}

public function WriteOptions()
{
  global $oDB;
  $oDB->Query('UPDATE '.TABSECTION.' SET options="'.$this->options.'" WHERE id='.$this->id);
}

public function ChangeStat($strKey,$strValue)
{
  QTargs('cSection->ChangeStat',array($strKey,$strValue));
  if ( $strKey==='' ) die ('cSection->ChangeStat: Missing key'); // $strKey can be ''

  $arr = QTarradd(QTexplode($this->stats),$strKey,$strValue);
  $this->stats = QTimplode($arr);
  $this->WriteOptions();
  return $arr;
}

public function ReadStats()
{
  $arr = QTexplode($this->stats);
  if ( isset($arr['topics']) ) $this->items = intval($arr['topics']);
  if ( isset($arr['replies']) ) $this->replies = intval($arr['replies']);
  if ( isset($arr['tabs']) ) $this->tabs = intval($arr['tabs']);
  if ( isset($arr['tags']) ) $this->tags = intval($arr['tags']);
  if ( isset($arr['topicsZ']) ) $this->topicsZ = intval($arr['topicsZ']);
  if ( isset($arr['repliesZ']) ) $this->repliesZ = intval($arr['repliesZ']);
  return $arr;
}

public function WriteStats()
{
  global $oDB;
  $oDB->Query('UPDATE '.TABSECTION.' SET stats="'.$this->stats.'" WHERE id='.$this->id);
}

// --------

}