<?php

function arrShift($arr,$oObj,$strDir)
{
  // Shifts an element up/down in the list. Keys are changed into numeric (0..n) except when $oObj is not found or impossible to move
  $arrS = array_values($arr); // Keys are replaced by an integer (0..n)
  $i = array_search($oObj,$arrS); // Search postition of $oObj, false if not found
  if ( $i===FALSE ) return $arr;
  if ( $i==0 && $strDir=='up' ) return $arr;
  if ( $i==(count($arr)-1) && $strDir=='down' ) return $arr;
  $arrO = $arrS;
  $intDir = ($strDir=='up' ? -1 : 1);
  $arrO[$i+$intDir] = $arrS[$i];
  $arrO[$i] = $arrS[$i+$intDir];
  return $arrO;
}

// --------

function ToCsv($str,$strSep=';',$strEnc='"',$strSepAlt=',',$strEncAlt="'")
{
  // Converts a value ($str) to a csv text with final separator [;]. A string is enclosed by ["].
  // When $str contains the separator or the encloser character, they are replaced by the alternates ($strSepAlt,$strEncAlt)
  // TIP: $strSep empty (or "\r\n") to generate a end-line value
  if ( is_int($str) || is_float($str) ) return $str.$strSep;
  if ( $str==='' || is_null($str) ) return $strEnc.$strEnc.$strSep;
  $str = str_replace('&nbsp;',' ',$str);
  $str = QTconv($str,'-4');
  $str = str_replace($strSep,$strSepAlt,$str);
  $str = str_replace($strEnc,$strEncAlt,$str);
  return $strEnc.$str.$strEnc.$strSep;
}