<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
require_once('bin/qtr_fn_admin.php');
include(Translate('qtr_adm.php'));
include(Translate('qtr_adm_tf.php'));

if ( $oVIP->role!='A' ) die(Error(13));

// --------
// INITIALISE
// --------

$a = '';
$tt = '*';
$id = '';
QThttpvar('a tt id','str str str');

$oVIP->selfurl = 'qtr_adm_fields.php';
$oVIP->selfname = '<span class="upper">'.$L['Adm_settings'].'</span><br/>'.$L['Fields'];

// Fields and tabs dictionary

CheckDico('field fielddesc');
CheckDico('tab tabdesc');

// --------
// SUBMITTED move, delete
// --------

if ( !empty($a) )
{
  if ( $a=='up' || $a=='down' )
  {
    $oDB->Query('SELECT fieldid FROM '.TABFIELD.' WHERE tabid="'.$tt.'" ORDER BY fieldorder');
    $arrList = array();
    while($row=$oDB->Getrow()) $arrList[]=$row['fieldid'];
    $arrO = array_values(arrShift($arrList,$id,$a));
    foreach($arrO as $intKey=>$strValue) $oDB->Query('UPDATE '.TABFIELD.' SET fieldorder='.$intKey.' WHERE tabid="'.$tt.'" AND fieldid="'.$strValue.'"');
  }
  if ( $a=='del' )
  {
     cField::Delete($id);
     $strInfo = $L['S_delete'];
  }
}

// --------
// SUBMITTED add field
// --------

if ( isset($_POST['okadd']) )
{
  // check id

  if ( get_magic_quotes_gpc() ) $id = stripslashes($id);
  $id = QTconv($id,'K');

  // Add tab

  if ( empty($error) )
  {
    $error = cField::Add($tt,$id);
    if ( empty($error) ) $strInfo = $L['S_insert'];
  }
}

// --------
// SUBMITTED add tab
// --------

if ( isset($_POST['oktab']) )
{
  // check id

  $id = trim($_POST['tabid']); if ( get_magic_quotes_gpc() ) $id = stripslashes($id);
  $id = QTconv($id,'K');
  
  // check section
  
  $intTo = intval($_POST['section']);

  // Add tab

  if ( empty($error) )
  {
    $error = cTab::Create($id,$intTo);
    if ( empty($error) ) { $strInfo = $L['S_insert']; $tt = $id; }
  }
}
// --------
// HTML START
// --------

$arrTabs = GetSectionTabs(-1);
$oTab = new cTab( array('tabid'=>'*','tabname'=>'('.strtolower($L['All']).')','tabdesc'=>ObjTrans('tabdesc','*',false)) );
$arrTabs = array_merge(array('*'=>$oTab),$arrTabs);

  $arrEditableTabids = array();
  foreach($arrTabs as $strKey=>$oTab)
  {
    if ( !in_array($strKey,array('*','ticket','messages','documents')) ) 
    {
    $arrEditableTabids[$strKey] = ObjTrans('tab',$oTab->tabname);
    }
  }

// Read fields

$arrFields = array();
$oDB->Query( 'SELECT * FROM '.TABFIELD.($tt==='*' ? ' ORDER BY tabid,fieldid' : ' WHERE tabid="'.$tt.'" ORDER by fieldorder') );
while($row=$oDB->Getrow()) { $arrFields[$row['fieldid']] = $row; }

// Add default values for the fields

foreach($arrFields as $strField=>$arrField)
{
  // add the default value (of this langue) if required
  $arrFields[$strField]['default'] = '';
  if ( $row['fielddefault']=='1' )
  {
    if ( strstr('SLP',$row['fieldtype']) )
    {
    if ( !isset($_SESSION['L']['list'][$strField]) ) $_SESSION['L']['list'][$strField] = cVIP::LangGet('list',GetIso(),$strField);
    $arrFields[$strField]['default'] = ObjTrans('list',$strField,false);
    }
    if ( $row['fieldtype']=='D' ) $arrFields[$strField]['default']=date('Ymd His');
    if ( $row['fieldtype']=='d' ) $arrFields[$strField]['default']=date('Ymd');
    if ( $row['fieldtype']=='T' ) $arrFields[$strField]['default']=date('H:i');
    if ( $row['fieldtype']=='C' ) $arrFields[$strField]['default']='1';
  }
}

// DISPLAY

include('qtr_adm_p_header.php');

HtmlTabs( $arrTabs, $oVIP->selfurl, $tt, 6, true, true, $L['E_editing'] );

// DISPLAY TAB PANEL

echo '<table class="pan" cellspacing="0" summary="panel content">
<tr class="pan">
<td class="pan">
<div class="pan_top">',( isset($_SESSION['L']['tabdesc'][$tt]) ? ObjTrans('tabdesc',$tt,false) : ObjTrans('tab',$tt) ),'</div>
';

// PREVIEW

if ( $tt!='*' )
{
  echo '
  <h2>',$L['Preview'],'</h2>
  <div style="margin:0; padding:15px; border:1px dotted #AAAAAA;">
  <table cellspacing="0" class="field">
  <colgroup span="3"><col width="150"></col><col></col><col></col></colgroup>
  ';
  if ( count($arrFields)==0 )
  {
    HtmlDataRow('0');
  }
  else
  {
    $str='';
    foreach($arrFields as $strField=>$arrField)
    {
      HtmlDataRow('D',$arrField,$str,$tt);
    }
  }
  echo '
  </table>
  </div>
  ';
}

if ( in_array($tt,array('ticket','messages','documents')) )
{
  echo '<p class="disabled">',$L['E_field_no_change'],' ',$arrTabs[$tt]->tabname,'.</p>';
}
else
{

  echo '<h2>',$L['Fields_upd'],' ',$arrTabs[$tt]->tabname,'</h2>';

  echo '
  <form method="post" action="',$oVIP->selfurl,'">
  <table cellspacing="0" class="data_o" summary="fields definition">
  <colgroup span="4"><col></col><col></col><col width="150"></col><col width="150"></col></colgroup>
  <tr class="data_o">
  <td class="colhd" style="text-align:left">',$L['Fields'],'</td>
  <td class="colhd" style="text-align:left">',$L['Style'],'</td>
  <td class="colhd">',$L['Action'],'</td>
  <td class="colhd">',( $tt=='*' ? 'Tab' : $L['Move']),'</td>
  </tr>
  ';
  $j=0;
  foreach($arrFields as $strField=>$arrField)
  {
    echo '<tr class="rowlight">',N;
    echo '<td class="colct bold"><a href="qtr_adm_field.php?tt=',$arrField['tabid'],'&amp;id=',$strField,'" title="Edit properties">',ObjTrans('field',$strField),'</a></td>',N;
    echo '<td class="colct"><span class="small">',$L['Field_type'][$arrField['fieldtype']],($arrField['fieldselect']=='0' ? ', '.strtolower($L['Visible_no']) : ''),($arrField['fieldupdate']=='0' ? ', '.strtolower($L['Editable_no']) : ''),'</span></td>',N;
    echo '<td class="colct center"><a class="small" href="qtr_adm_field.php?tt=',$tt,'&amp;id=',$strField,'">',$L['Edit'],'</a>&nbsp;&middot;&nbsp;<a class="small" href="',$oVIP->selfurl,'?tt=',$tt,'&amp;id=',$strField,'&amp;a=del">',$L['Delete'],'</a></td>',N;
    echo '<td class="colct center">';
    if ( $tt=='*' )
    {
    echo '<span class="small">',ObjTrans('tab',$arrField['tabid']),'</span>';
    }
    else
    {
    if ( $j==0 ) { echo '<span class="disabled">',$L['Up'],'</span>'; } else { echo '<a class="small" href="',$oVIP->selfurl,'?tt=',$tt,'&amp;id=',$strField,'&amp;a=up">',$L['Up'],'</a>'; }
    echo ' &middot; ';
    if ( $j+1==count($arrFields) ) { echo '<span class="disabled">',$L['Down'],'</span>'; } else { echo '<a class="small" href="',$oVIP->selfurl,'?tt=',$tt,'&amp;id=',$strField,'&amp;a=down">',$L['Down'],'</a>'; }
    }
    echo '</td></tr>',N;
    $j++;
  }
  if ( count($arrFields)==0 ) echo '<tr class="data_o"><td class="colct disabled" colspan="7">',$L['None'],'...</td></tr>';

  // ADD FIELD

  if ( count($arrEditableTabids)>0 )
  {
  echo '
  <tr class="data_o">
  <td class="colgroup" colspan="4"><input type="text" id="id" name="id" value="" size="24" maxlength="24" class="small"/>
  ';
  if ( $tt=='*' )
  {
    echo ' in <select id="tt" name="tt" class="small">',QTasTag($arrEditableTabids),'</select>';
  }
  else
  {
    echo '<input type="hidden" id="tt" name="tt" value="',$tt,'"/>';
  }
  echo '
   <input type="submit" id="okadd" name="okadd" class="small" value="',$L['Field_add'],'"/></td>
  </tr>';
  }
  else
  {
  echo '
  <tr class="data_o"><td class="colct" colspan="4"><span class="disabled">',$L['E_no_editable_tab'],'</span></td></tr>';
  }

echo '
</table>
</form>
';

}

// END TAB PANEL

echo '
</td>
</tr>
</table>
';

// Under main page

echo '<h2>',$L['Other_action'],'</h2>
<form method="post" action="',$oVIP->selfurl,'">
<p>
<label for="tabid">',$L['Create_tab'],'</label> <input type="text" id="tabid" name="tabid" value="" size="24" maxlength="24"/> <label for="section">',strtolower($L['In_section']),'</label>
<select id="section" name="section">',Sectionlist(),'</select> <input type="submit" id="oktab" name="oktab" value="',$L['Ok'],'"/>
</p>
</form>
';

// --------
// HTML END
// --------

include('qtr_adm_p_footer.php');