<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
require_once('bin/qtr_fn_admin.php');
include(Translate('qtr_adm.php'));

if ( $oVIP->role!='A' ) die(Error(13));

// INITIALISE

$a='';
$d=-1;
$s=-1;
QThttpvar('a d s','str int int');

$oVIP->selfurl = 'qtr_adm_sections.php';
$oVIP->selfname = '<span class="upper">'.$L['Adm_content'].'</span><br/>'.$L['Sections'];

// --------
// SUBMITTED
// --------

// ADD DOMAIN

if ( isset($_POST['add_dom']) )
{

  $oGP = new cGetPost($_POST['title'],64);
  if ( empty($oGP->e) ) $error = $L['Domain'].'/'.$L['Section'].' '.Error(1);
  
  if ( empty($error) )
  {
    require_once('bin/qtr_class_dom.php');
    cDomain::Create($oGP->e,-1);
  }
}

// ADD SECTION

if ( isset($_POST['add_sec']) )
{

  $oGP = new cGetPost($_POST['title'],64);
  if ( empty($oGP->e) ) $error = $L['Domain'].'/'.$L['Section'].' '.Error(1);

  // Add section
  if ( empty($error) ) cSection::Create($oGP->e,intval($_POST['indomain']));
}

// Move domain/section

if ( !empty($a) )
{
  if ( $a=='d_up' || $a=='d_down' )
  {
    $oDB->Query('SELECT id FROM '.TABDOMAIN.' ORDER BY titleorder');
    $arrList = array();
    while($row=$oDB->Getrow()) $arrList[]=intval($row['id']);
    $arrO = array_values(arrShift($arrList,$d,substr($a,2)));
    foreach($arrO as $intKey=>$intId) $oDB->Query('UPDATE '.TABDOMAIN.' SET titleorder='.$intKey.' WHERE id='.$intId);
    if ( isset($_SESSION[QT]['sys_domains']) ) Unset($_SESSION[QT]['sys_domains']);
    if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
  }
  if ( $a=='f_up' || $a=='f_down' )
  {
    $oDB->Query('SELECT id FROM '.TABSECTION.' WHERE domainid='.$d.' ORDER BY titleorder');
    $arrList = array();
    while($row=$oDB->Getrow()) $arrList[]=intval($row['id']);
    $arrO = array_values(arrShift($arrList,$s,substr($a,2)));
    foreach($arrO as $intKey=>$intId) $oDB->Query('UPDATE '.TABSECTION.' SET titleorder='.$intKey.' WHERE id='.$intId);
    if ( isset($_SESSION[QT]['sys_sections']) ) Unset($_SESSION[QT]['sys_sections']);
  }
}

// --------
// HTML START
// --------

$arrDomains = GetDomains();
if ( count($arrDomains)>50 ) $warning='You have too much domains. Try to remove unused domains.';
$arrSections = GetSections('A',-2); // Optimisation: get all sections at once (grouped by domain)
if ( count($arrSections)>100 ) $warning='You have too much sections. Try to remove unused sections.';

include('qtr_adm_p_header.php');

$strYes = $L['Y'];
$strNo = '<span class="disabled">'.$L['N'].'</span>';

echo '
<p style="text-align:right"><a id="toggleforms" href="qtr_adm_sections.php" onclick="ToggleForms(); return false;">',$L['Add'],' ',$L['Domain'],'/',$L['Section'],'...</a></p>
';

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("',$L['Missing'],': ',$L['Domain'],'/',$L['Section'],'")); return false; }
  return null;
}
function ToggleForms()
{
  if ( document.getElementById("adddomain").style.display=="none" )
  {
  document.getElementById("adddomain").style.display="block"; 
  document.getElementById("addsection").style.display="block"; 
  }
  else
  {
  document.getElementById("adddomain").style.display="none"; 
  document.getElementById("addsection").style.display="none"; 
  }
}
-->
</script>
';
echo '<form id="adddomain" method="post" action="qtr_adm_sections.php" onsubmit="return ValidateForm(this);">
<table class="data_o" cellspacing="0">
<tr class="data_o">
<td class="colgroup" style="width:120px;"><label for="domain">',$L['Domain_add'],'</label></td>
<td class="colgroup"><input id="domain" name="title" type="text" size="30" maxlength="64"/></td>
<td class="colgroup" style="width:50px;"><input id="add_dom" name="add_dom" type="submit" value="',$L['Add'],'"/></td>
</tr>
</table>
</form>
';
echo '<form id="addsection" method="post" action="qtr_adm_sections.php" onsubmit="return ValidateForm(this);">
<table class="data_o" cellspacing="0" style="margin-bottom:10px">
<tr class="data_s">
<td class="colct" style="width:120px;"><label for="section">',$L['Section_add'],'</label></td>
<td class="colct">
<input id="section" name="title" type="text" size="30" maxlength="64" class="small"/> <span class="small">',strtolower($L['In_domain']),'</span> <select name="indomain" size="1" class="small">',QTasTag($arrDomains),'</select>
</td>
<td class="colct" style="width:50px;"><input name="add_sec" type="submit" value="',$L['Add'],'"/></td>
</tr>
</table>
</form>
';
if ( !isset($_POST['title']) ) echo '<script type="text/javascript">ToggleForms();</script>';

echo '
<table class="data_o" cellspacing="0" summary="sections">
<colgroup span="7"><col width="50"></col><col></col><col></col><col></col><col></col><col></col><col></col></colgroup>
<tr class="data_s">
<td class="colhd" colspan="2">',$L['Domain'],'/',$L['Section'],'</td>
<td class="colhd">',$L['Userrole_MF'],'</td>
<td class="colhd">',$L['Ref'],'</td>
<td class="colhd">Tab</td>
<td class="colhd">',$L['Action'],'</td>
<td class="colhd">',$L['Move'],'</td>
</tr>
';

$i=0;
foreach($arrDomains as $intDomain=>$strDomain)
{
  echo '<tr class="data_o">',PHP_EOL;
  echo '<td class="colgroup" colspan="2">',$strDomain,'</td>',PHP_EOL;
  echo '<td class="colgroup">&nbsp;</td>',PHP_EOL;
  echo '<td class="colgroup">&nbsp;</td>',PHP_EOL;
  echo '<td class="colgroup">&nbsp;</td>',PHP_EOL;
  echo '<td class="colgroup" style="text-align:center"><a class="small" href="qtr_adm_domain.php?d=',$intDomain,'">',$L['Edit'],'</a>';
  echo ' &middot; ',($intDomain==0 ? '<span class="disabled">'.$L['Delete'].'</span>' : '<a class="small" href="qtr_adm_change.php?a=deletedomain&amp;d='.$intDomain.'">'.$L['Delete'].'</a>'),'</td>';
  echo '<td class="colgroup" style="text-align:center;">';
  if ( $i==0 )
  {
  echo '<span class="disabled">',$L['Up'],'</span>';
  }
  else
  {
  echo '<a class="small" href="qtr_adm_sections.php?d=',$intDomain,'&amp;a=d_up">',$L['Up'],'</a>';
  }
  echo ' &middot; ';
  if ( $i+1==count($arrDomains) )
  {
  echo '<span class="disabled">',$L['Down'],'</span>';
  }
  else
  {
  echo '<a class="small" href="qtr_adm_sections.php?d=',$intDomain,'&amp;a=d_down">',$L['Down'],'</a>';
  }
  echo '</td>',PHP_EOL;
  echo '</tr>',PHP_EOL;

  $i += 1;
  $j = 0;
  if ( isset($arrSections[$intDomain]) ) {
  if ( count($arrSections[$intDomain])>0 ) {
  foreach($arrSections[$intDomain] as $intSecid=>$arrSection) {
  
    $oSEC = new cSection($arrSection);    
    echo '<tr class="data_o">';
    echo '<td class="colct" style="text-align:center">',AsImg($oSEC->GetLogo(),'S',$L['Ico_section_'.$oSEC->type.'_'.$oSEC->status],'ico i_sec','','qtr_adm_section.php?s='.$oSEC->id),'</td>';
    echo '<td class="colct"><a class="bold" href="qtr_adm_section.php?s=',$oSEC->id,'">',$oSEC->name,'</a><br/><span class="small">',$L['Section_type'][$oSEC->type],($oSEC->status==1 ? ', '.strtolower($L['Section_status'][1]) : ''),'</span> ',AsImg('admin/ico_notify_'.( $oSEC->notify==1 ? 'on' : 'off' ).'.gif','N',$L['Notification'].': '.( $oSEC->notify==1 ? $L['Y'] : $L['N'] ),'ico i_topic'),'</td>';
    echo '<td class="colct" style="text-align:center">',$oSEC->modname,'</td>';
    echo '<td class="colct" style="text-align:center">',( $oSEC->numfield=='N' ? $strNo : sprintf($oSEC->numfield,1) ),'</td>';
    echo '<td class="colct" style="text-align:center"><a class="small" href="qtr_adm_tabs.php?s=',$oSEC->id,'">',$oSEC->tabs,' tabs</a></td>';
    echo '<td class="colct" style="text-align:center"><a class="small" href="qtr_adm_section.php?s=',$oSEC->id,'">',$L['Edit'],'</a>';
    echo ' &middot; ',($intSecid==0 ? '<span class="disabled">'.$L['Delete'].'</span>' : '<a class="small" href="qtr_adm_change.php?a=deletesection&amp;s='.$intSecid.'">'.$L['Delete'].'</a>'),'</td>';
    echo '<td class="colct" style="text-align:center">';
    if ( $j==0 ) { echo '<span class="disabled">',$L['Up'],'</span>'; } else { echo '<a class="small" href="qtr_adm_sections.php?d=',$intDomain,'&amp;s=',$intSecid,'&amp;a=f_up">',$L['Up'],'</a>'; }
    echo ' &middot; ';
    if ( $j+1==count($arrSections) ) { echo '<span class="disabled">',$L['Down'],'</span>'; } else { echo '<a class="small" href="qtr_adm_sections.php?d=',$intDomain,'&amp;s=',$intSecid,'&amp;a=f_down">',$L['Down'],'</a>'; }
    $j += 1;
    echo '</td></tr>',N;
    
  }}}
}

echo '</table>
';

include('qtr_adm_p_footer.php');