<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package    Q-registration
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110715
 */

session_start();
require_once('bin/qtr_init.php');
if ( $oVIP->role!='A' ) die($L['R_admin']);
include(Translate('qtr_adm.php'));

// ---------
// INITIALISE
// ---------

$oVIP->selfurl = 'qtr_adm_sections_stat.php';
$oVIP->selfname = '<span class="upper">'.$L['Adm_content'].'</span><br />'.$L['Sections'].'<br />'.$L['Update_stats'];
$oVIP->exiturl = 'qtr_adm_topic.php';
$oVIP->exitname = '&laquo; '.$L['Topics'];

$arrDomains = GetDomains(); 
if ( count($arrDomains)>50 ) $warning='You have too much domains. Try to remove unused domains.';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  $arr = array();
  foreach(array_keys($arrDomains) as $id)
  {
  if ( isset($_POST['domain'.$id]) ) $arr = array_merge($arr,$_POST['domain'.$id]);
  }
  if ( count($arr)>0 )
  {
  foreach($arr as $id) UpdateSectionStats($id);
  $strInfo = LangS('Section',count($arr)).'. '.$L['S_update'];
  }
  else
  {
  $warning = $L['E_nothing_selected'];
  }
}

// ---------
// INITIALISE (after update to show new values)
// ---------

$arrSections = GetSections('A',-2); // Optimisation: get all sections at once (grouped by domain)
$intSections=0;
foreach($arrSections as $arr) $intSections += count($arr);
if ( $intSections>100 ) $warning='You have too much sections. Try to remove unused sections.';

// --------
// HTML START
// --------

$strHeadScript = '
<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript" src="bin/qtr_table.js"></script>
<script type="text/javascript">
<!--
$(document).ready(function() {
  $(".checkboxdomain").click(function() { qtCheckboxAll(this.id,this.id+"[]",true); }); // false  when no row hightlight
  $(".checkboxsection").click(function() { qtHighlight("tr_"+this.id,this.checked); }); // delete when no row hightlight
});
-->
</script>
';

include('qtr_adm_p_header.php');

echo '<form method="post" action="qtr_adm_sections_stat.php">',PHP_EOL;
if ( $intSections>3 ) echo '<p style="margin:4px 0"><img src="admin/selection_up.gif" style="width:10px;height:10px;vertical-align:bottom;margin:2px 10px 0 15px" alt="|" />',$L['Selection'],': <input type="submit" class="small" name="ok" value="',$L['Update_stats'],'" /></p>',PHP_EOL;
echo '<table class="data_o" cellspacing="0" summary="section statistics">
<colgroup span="7"><col width="30"></col><col width="30"></col><col></col><col></col><col></col><col></col><col></col></colgroup>
<tr class="tr">
<td class="colhd">&nbsp;</td>
<td class="colhd" colspan="2" style="text-align:left">',$L['Domain'],'/',$L['Section'],'</td>
<td class="colhd">',$L['Topics'],'</td>
<td class="colhd">',$oVIP->statuses['Z']['statusname'],' (',$L['Status'],' Z)</td>
<td class="colhd">',$L['Replys'],'</td>
<td class="colhd">',$L['Tags'],'</td>
</tr>
';

$i=0;
foreach($arrDomains as $intDomain=>$strDomain)
{
  if ( isset($arrSections[$intDomain]) ) {
  if ( count($arrSections[$intDomain])>0 ) {

    echo '<tr class="tr">',PHP_EOL;
    echo '<td class="colgroup"><input type="checkbox" id="domain'.$intDomain.'" class="checkboxdomain"',(count($arrSections[$intDomain])<3 ? ' style="display:none"' : ''),' /></td>',PHP_EOL;
    echo '<td class="colgroup" colspan="3">',$strDomain,'</td>',PHP_EOL;
    echo '<td class="colgroup">&nbsp;</td>',PHP_EOL;
    echo '<td class="colgroup">&nbsp;</td>',PHP_EOL;
    echo '<td class="colgroup">&nbsp;</td>',PHP_EOL;
    echo '</tr>',PHP_EOL;

    $i += 1;

    $j = 0;
    foreach($arrSections[$intDomain] as $arrSection)
    {
      $oSEC = new cSection($arrSection);
      echo '<tr class="rowlight" id="tr_section'.$oSEC->id.'">',PHP_EOL;
      echo '<td class="colct center"><input type="checkbox" class="checkboxsection" name="domain'.$intDomain.'[]" id="section'.$oSEC->id.'" value="'.$oSEC->id.'" onclick="qtCheckboxOne(\'domain'.$intDomain.'[]\',\'domain'.$intDomain.'\');" /></td>',PHP_EOL;
      echo '<td class="colct center"><label for="section'.$oSEC->id.'">',AsImg($_SESSION[QT]['skin_dir'].'/ico_section_'.$oSEC->type.'_'.$oSEC->status.'.gif','[+]',$L['Ico_section_'.$oSEC->type.'_'.$oSEC->status],'ico i_sec20'),'</label></td>';
      echo '<td class="colct"><label for="section'.$oSEC->id.'"><span class="bold">',$oSEC->name,'</span> &middot; <span class="small">',$L['Section_type'][$oSEC->type],($oSEC->status=='1' ? '<span class="small"> ('.$L['Section_status'][1].')</span>' : ''),'</span></label></td>';
      echo '<td class="colct center">',$oSEC->items,'</td>',PHP_EOL;
      echo '<td class="colct center">',$oSEC->topicsZ,'</td>',PHP_EOL;
      echo '<td class="colct center">',$oSEC->replies,'</td>',PHP_EOL;
      echo '<td class="colct center">',$oSEC->tags,'</td>',PHP_EOL;
      echo '</tr>',PHP_EOL;
    }
    
  }}
}
echo '</table>
<p style="margin:4px 0"><img src="admin/selection_down.gif" style="width:10px;height:10px;vertical-align:top;margin:2px 10px 0 15px" alt="|" />',$L['Selection'],': <input type="submit" class="small" name="ok" value="',$L['Update_stats'],'" /></p>
</form>
<p><a href="',$oVIP->exiturl,'">',$oVIP->exitname,'</a></p>
';

// --------
// HTML END
// --------

include('qtr_adm_p_footer.php');