<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');

// INITIALISE

$bCmdok = false;
$strMails = '';

$a = ''; // mandatory action
$s = -1; // section
$t = -1; // topic
$p = -1; // post
$v = ''; // value
$v1 = ''; // value
$v2 = ''; // value
$v3 = ''; // value
$ok = ''; // submitted
QThttpvar('a s t p v v1 v2 v3 ok','str int int int str str str str str',true,true,false); // reject post method

$oVIP->selfurl = 'qtr_change.php';
$oVIP->selfname = 'Q-registerations command';

// --------
// EXECUTE COMMAND
// --------

switch($a)
{

// --------------
case 'docrename':
// --------------

  if ( $p<0 ) die('Wrong user in '.$oVIP->selfurl); // $p is the document owner
  if ( $p!=$oVIP->id && $oVIP->role!='A' && $oVIP->role!='M' ) die('Wrong user in '.$oVIP->selfurl);

  $oVIP->selfname = $L['Document_name'];
  $oVIP->exiturl = 'qtr_topic.php?s='.$s.'&amp;t='.$t.'&amp;tt=documents';
  $oVIP->exitname = '&laquo; '.$L['Topic'];

  // ask confirmation
  if ( empty($ok) )
  {
    $oDB->Query('SELECT * FROM '.TABDOC.' WHERE docfile="'.$v.'"');
    $row=$oDB->Getrow();

    $oVIP->EndMessage
    (
    NULL,
    '<table class="hidden" cellspacing="0">
    <tr class="hidden">
    <td class="hidden"></td>
    <td class="hidden"><form method="get" action="'.Href().'">
    <p><span class="bold">'.$row['docname'].'</span> ('.QTdatestr($row['docdate']).')</p>
    <p><input type="text" name="name" id="name" size="50" maxlength="255" value="'.$row['docname'].'"/>
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="hidden" name="t" value="'.$t.'"/>
    <input type="hidden" name="p" value="'.$p.'"/>
    <input type="hidden" name="v" value="'.$v.'"/>
    <input type="submit" name="ok" value="'.$L['Ok'].'"/></p>
    </form></td>
    </tr></table>',
    $_SESSION[QT]['skin_dir'],
    0,
    '500px'
    );
    exit;
  }

  // CHANGE

  $str = QTconv(trim(strip_tags($_GET['name'])),'3'); if ( empty($str) ) $str='Untitled';
  $oDB->Query( 'UPDATE '.TABDOC.' SET docname="'.$str.'" WHERE docfile="'.$v.'"');

  // EXIT

  $oVIP->EndMessage('0');
  break;

// --------------
case 'docdelete':
// --------------

if ( $p<0 ) die('Wrong user in '.$oVIP->selfurl); // $p is the document owner
if ( $p!=$oVIP->id && $oVIP->role!='A' && $oVIP->role!='M') die('Wrong user in '.$oVIP->selfurl);

$oVIP->selfname = $L['Delete'];
$oVIP->exiturl = 'qtr_topic.php?s='.$s.'&amp;t='.$t.'&amp;tt=documents';
$oVIP->exitname = '&laquo; '.$L['Topic'];

$oDB->Query('SELECT * FROM '.TABDOC.' WHERE docfile="'.$v.'"');
$row=$oDB->Getrow();

// ask confirmation
if ( empty($ok) )
{
  $oVIP->EndMessage
  (
  NULL,
  '<table class="hidden" cellspacing="0">
  <tr class="hidden">
  <td class="hidden"></td>
  <td class="hidden"><form method="get" action="'.Href().'">
  <p><span class="bold">'.$row['docname'].'</span> ('.QTdatestr($row['docdate']).')</p>
  <p class="center"><input type="hidden" name="a" value="'.$a.'"/>
  <input type="hidden" name="s" value="'.$s.'"/>
  <input type="hidden" name="t" value="'.$t.'"/>
  <input type="hidden" name="p" value="'.$p.'"/>
  <input type="hidden" name="v" value="'.$v.'"/>
  <input type="submit" name="ok" value="'.$L['Delete'].'"/></p>
  </form></td>
  </tr></table>',
  $_SESSION[QT]['skin_dir'],
  0,
  '500px'
  );
  exit;
}

// DELETE

$oDB->Query( 'DELETE FROM '.TABDOC.' WHERE docfile="'.$v.'"');
if ( file_exists($row['docpath'].$v) ) unlink($row['docpath'].$v);
if ( file_exists($row['docpath'].'thumb_'.$v) ) unlink($row['docpath'].'thumb_'.$v);

// EXIT

$oVIP->EndMessage('0');
break;

// --------------
case 'pwdreset':
// --------------

  if ( $oVIP->role!='A' ) die('Access is restricted to administrators only.');

  if ( $s<0 ) die('Wrong id '.$s);
  if ( $s==1 && $oVIP->id!=1 ) die('First Admin password can be changed by himself only...');
  include('bin/qt_lib_smtp.php');
  include(Translate('qtr_reg.php'));

  $oVIP->selfname = $L['Reset_pwd'];
  $oVIP->exiturl  = 'qtr_user.php?id='.$s;
  $oVIP->exitname = '&laquo; '.$L['Profile'];

  $oDB->Query('SELECT name,mail,children,parentmail,photo FROM '.TABUSER.' WHERE id='.$s);
  $row = $oDB->Getrow();
  $row['name'] = QTconv($row['name'],'5');

  // ask delay
  if ( empty($ok) )
  {
    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.Href().'">
    <table class="hidden" cellspacing="0">
    <tr class="hidden">
    <td class="hidden">'.AsImgBox(AsImg( (empty($row['photo']) ? '' : QTR_DIR_PIC.$row['photo']),'',$row['name']),'picbox','',$row['name']).'</td>
    <td class="hidden">
    <p style="text-align:right">'.$L['Reset_pwd_help'].'<br/><br/>'.$oVIP->selfname.'&nbsp;
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="submit" name="ok" value="'.$L['Send'].'"/></p>
    </td>
    </tr>
    </table></form>',
    'admin',
    0,
    '500px'
    );
    exit;
  }

  // reset user
  $strNewpwd = 'qt'.rand(0,9).rand(0,9).rand(0,9).rand(0,9);
  $oDB->Query('UPDATE '.TABUSER.' SET pwd="'.sha1($strNewpwd).'" WHERE id='.$s);

  // send email
  $strSubject = $_SESSION[QT]['site_name'].' - New password';
  $strMessage = "Here are your login and password\nLogin: %s\nPassword: %s";
  $strFile = Translate('mail_pwd.php');
  if ( file_exists($strFile) ) include($strFile);
  $strMessage = sprintf($strMessage,$row['name'],$strNewpwd);
  QTmail($row['mail'],QTconv($strSubject,'-4'),QTconv($strMessage,'-4'),QTR_HTML_CHAR);
  $strEndmessage = str_replace("\n",'<br/>',$strMessage);

  // send parent email (if coppa)
  if ( QTR_USE_COPPA && $row['children']!='0' )
  {
    $strSubject = $_SESSION[QT]['site_name'].' - New password';
    $strMessage = "Here is then new password of your children.\nLogin: %s\nPassword: %s";
    $strFile = Translate('mail_pwd_coppa.php');
    if ( file_exists($strFile) ) { include($strFile); }
    $strMessage = sprintf($strMessage, $row['name'],$strNewpwd);
    QTmail($row['parentmail'],QTconv($strSubject,'-4'),QTconv($strMessage,'-4'),QTR_HTML_CHAR);
  }

  // exit
  $oVIP->EndMessage(NULL,$L['S_update'].'<br/><br/>Email:<br/><br/>'.$strEndmessage,$_SESSION[QT]['skin_dir'],0);
  exit;
  break;

// --------------
case 'topicstatus':
// --------------

  if ( $oVIP->role!='A' && $oVIP->role!='M' ) die(Error(12));
  if ( !$oVIP->CanView('V6') ) die(Error(11));

  $oVIP->selfname = $L['Change'].' '.$L['Status'];
  $oVIP->exiturl  = "qtr_topic.php?s=$s&amp;t=$t";
  $oVIP->exitname = '&laquo; '.$L['Message'];

  // ASK STATUS IF MISSING: When value "*" repost with method GET

  if ( $v=='*' )
  {
    $oVIP->EndMessage
    (
      NULL,
      '<form method="get" action="'.Href().'">
      <input type="hidden" name="a" value="'.$a.'"/>
      <input type="hidden" name="s" value="'.$s.'"/>
      <input type="hidden" name="t" value="'.$t.'"/>
      <select name="v" size="8">'.QTasTag($oVIP->statuses,'',array('format'=>$L['Status'].': %s')).'</select><br/><br/>
      <input type="submit" name="ok" value="'.$L['Ok'].'"/>
      </form>',
      $_SESSION[QT]['skin_dir']
    );
    exit;
  }

  // CHANGE STATUS

  $oTopic = new cTopic($t);
  $oTopic->SetStatus($v,true,$oTopic->firstpostid);
  if ( $v=='Z' )
  {
    $oVIP->exitname = '&laquo; '.$L['Section'];
    $oVIP->exiturl = "qtr_topics.php?s=$s";
    UpdateSectionStats($s);
  }

  // EXIT

  $oVIP->EndMessage(NULL,$L['S_update'].$strMails,$_SESSION[QT]['skin_dir'],2);
  exit;
  break;

// --------------
case 'topictype':
// --------------

  if ( $oVIP->role!='A' && $oVIP->role!='M' ) die(Error(12));

  $oVIP->selfname = $L['Change'].' '.$L['Style'];
  $oVIP->exiturl  = "qtr_topic.php?s=$s&amp;t=$t";
  $oVIP->exitname = $L['Message'];

  // ASK TYPE IF MISSING: When value "*" repost with method GET
  if ( $v=='*' )
  {
    $oVIP->EndMessage
    (
      NULL,
      '<form method="get" action="'.Href().'">
      <input type="hidden" name="a" value="'.$a.'"/>
      <input type="hidden" name="s" value="'.$s.'"/>
      <input type="hidden" name="t" value="'.$t.'"/>
      <select name="v" size="6">'.
      QTasTag($oVIP->types).'
      </select><br/><br/><input type="submit" name="ok" value="'.$L['Ok'].'"/>
      </form>',
      $_SESSION[QT]['skin_dir']
    );
    exit;
  }

  // CHANGE TYPE

  cTopic::SetType($t,$v);
  if ( $v=='I' ) $oHtml->Redirect('qtr_change.php?a=topicparam&amp;s='.$s.'&amp;t='.$t);
  
  // EXIT

  $oVIP->EndMessage(NULL,$L['S_update'],$_SESSION[QT]['skin_dir'],2);
  exit;
  break;

// --------------
case 'topicactor':
// --------------

  if ( $oVIP->role!='A' && $oVIP->role!='M' ) die(Error(12));

  $oVIP->selfname = $L['Change'].' '.$L['Userrole_MA'];
  $oVIP->exiturl  = "qtr_topic.php?s=$s&amp;t=$t";
  $oVIP->exitname = $L['Message'];
  $intOldactor    = -1; if ( isset($_GET['old']) ) $intOldactor=$_GET['old'];

  // ASK ACTOR IF MISSING: When value "*" repost with method GET
  if ( $v=='*' )
  {
    $arrAdmUsers = GetUsers('A');
    asort($arrAdmUsers);
    $arrModUsers = GetUsers('M-');
    asort($arrModUsers);
    $oVIP->selfname = $L['Change'].' '.$L['Userrole_MA'];
    $oVIP->EndMessage
    (
      NULL,
      '<table class="hidden" cellspacing="0">
      <tr class="hidden">
      <td class="hidden">
      '.$L['Userrole']['A'].'<br/><br/>
      <form method="get" action="'.Href().'">
      <input type="hidden" name="a" value="'.$a.'"/>
      <input type="hidden" name="s" value="'.$s.'"/>
      <input type="hidden" name="t" value="'.$t.'"/>
      <select name="v" size="12">'.QTasTag($arrAdmUsers,$intOldactor,array('classC'=>'bold','current'=>$intOldactor)).'</select><br/><br/>
      <input type="submit" name="ok" value="'.$L['Ok'].'"/>
      </form></td>
      <td class="hidden">
      '.$L['Userrole']['M'].'<br/><br/>
      <form method="get" action="'.Href().'">
      <input type="hidden" name="a" value="'.$a.'"/>
      <input type="hidden" name="s" value="'.$s.'"/>
      <input type="hidden" name="t" value="'.$t.'"/>
      <select name="v" size="12">'.QTasTag($arrModUsers,$intOldactor,array('classC'=>'bold','current'=>$intOldactor)).'</select><br/><br/>
      <input type="submit" name="ok" value="'.$L['Ok'].'"/>
      </form></td>
      </tr></table>',
      $_SESSION[QT]['skin_dir']
    );
    exit;
  }
  $v = intval($v);

  // CHANGE ACTOR
  $oTopic = new cTopic($t);
  $oTopic->SetActor($v);

  // EXIT

  $oVIP->EndMessage(NULL,$L['S_update'],$_SESSION[QT]['skin_dir'],2);
  exit;
  break;

// --------------
case 'userrole':
// --------------

  if ( $oVIP->role!='A' && $oVIP->role!='M' ) die(Error(12));
  if ( $s<2 ) die('Wrong parameters: user 0 and 1 cannot be changed');
  include(Translate('qtr_reg.php'));

  $oVIP->selfname = $L['User_upd'];
  $oVIP->exiturl  = 'qtr_user.php?id='.$s;
  $oVIP->exitname = $L['Memberlist'];

  // ask confirmation
  if ( empty($ok) )
  {
    $oDB->Query('SELECT name,photo,role FROM '.TABUSER.' WHERE id='.$s);
    $row = $oDB->Getrow();

    $oVIP->EndMessage
    (
      NULL,
      '<table class="hidden" cellspacing="0">
      <tr class="hidden">
      <td class="hidden">'.AsImgBox(AsImg( (empty($row['photo']) ? '' : QTR_DIR_PIC.$row['photo']),'',$row['name']),'picbox','',$row['name']).'</td>
      <td class="hidden">
      <form method="get" action="'.Href().'">
      <h2>'.$row['name'].' ('.$L['Userrole'][$row['role']].')</h2><br/>
      <label for="r">'.$L['Change_role'].' </label><select id="r" name="r" size="1">
      <option value="A"'.($row['role']=='A' ? QSEL : '').($oVIP->role!='A' ? ' disabled="disabled"' : '').'>'.$L['Userrole']['A'].'</option>
      <option value="M"'.($row['role']=='M' ? QSEL : '').'>'.$L['Userrole']['M'].'</option>
      <option value="U"'.($row['role']=='U' ? QSEL : '').'>'.$L['Userrole']['U'].'</option>
      </select>&nbsp;<input type="hidden" name="a" value="'.$a.'"/>
      <input type="hidden" name="s" value="'.$s.'"/>
      <input type="submit" name="ok" value="'.$L['Ok'].'"/>
      </form></td>
      </tr>
      </table>',
      'admin',
      0,
      '500px'
    );
    exit;
  }

  //update role
  if ( $oVIP->role!='A' && $v=='A' ) die('Access is restricted to administrators only.');
  $oDB->Query('UPDATE '.TABUSER.' SET role="'.$_GET['r'].'" WHERE id='.$s);
  if ( $_GET['r']=='U' ) $oDB->Query('UPDATE '.TABSECTION.' SET moderator=1, moderatorname="Admin" WHERE moderator='.$s);

  // exit
  $oVIP->EndMessage(NULL,$L['S_update'],'admin',2);
  exit;
  break;

// --------------
case 'user_del':
// --------------

  if ( $oVIP->role!='A' && $oVIP->role!='M' ) die(Error(12));
  if ( $s<2 ) die("Wrong parameters: user 0 and 1 cannot be deleted");
  include(Translate("qtr_reg.php"));

  $oVIP->selfname = $L['User_del'];
  if ( $v=='adm' ) 
  {
  $oVIP->exiturl = 'qtr_adm_users.php';
  $oVIP->exitname = '&laquo; '.$L['Users'];
  }
  else
  {
  $oVIP->exiturl  = 'qtr_member.php';
  $oVIP->exitname = '&laquo; '.$L['Memberlist'];
  }

  $oDB->Query('SELECT name,photo FROM '.TABUSER.' WHERE id='.$s);
  $row = $oDB->Getrow();

  // ask confirmation
  if ( empty($ok) )
  {
    $str  = '<table class="hidden" cellspacing="0">';
    $str .= '<tr class="hidden">'.N;
    $str .= '<td class="hidden">'.AsImgBox(AsImg( (empty($row['photo']) ? '' : QTR_DIR_PIC.$row['photo']),'',$row['name']),'picbox','',$row['name']).'</td>';
    $str .= '<td class="hidden">';
    $str .= '<form method="get" action="'.Href().'">';
    $str .= '<p style="text-align:right">'.$L['User_del'].' '.$row['name'].' ';
    $str .= '<input type="hidden" name="a" value="'.$a.'"/><input type="hidden" name="v" value="'.$v.'"/><input type="hidden" name="s" value="'.$s.'"/><input type="submit" name="ok" value="'.$L['Delete'].'"/></p>';
    $str .= '</form></td>'.N;
    $str .= '</tr></table></form>'.N;
    $oVIP->EndMessage(NULL,$str,'admin',0,'500px');
    exit;
  }

  // delete avatar first
  if ( file_exists(QTR_DIR_PIC.$row['photo']) ) unlink(QTR_DIR_PIC.$row['photo']);

  // update post.userid, post.username, topic.firstpostuser, topic.lastpostuser, topic.firstpostname, topic.lastpostname
  $oDB->Query('UPDATE '.TABPOST.' SET userid=0, username="Visitor" WHERE userid='.$s);
  $oDB->Query('UPDATE '.TABTOPIC.' SET firstpostuser=0, firstpostname="Visitor" WHERE firstpostuser='.$s);
  $oDB->Query('UPDATE '.TABTOPIC.' SET lastpostuser=0, lastpostname="Visitor" WHERE lastpostuser='.$s);
  $oDB->Query('UPDATE '.TABSECTION.' SET moderator=1,moderatorname="Admin" WHERE moderator='.$s);

  // delete user
  $oDB->Query('DELETE FROM '.TABUSER.' WHERE id='.$s);

  // Unregister global sys (will be recomputed on next page)
  Unset($_SESSION[QT]['sys_members']);
  Unset($_SESSION[QT]['sys_states']);

  // exit
  $oVIP->EndMessage(NULL,$L['S_delete'],'admin',2);
  exit;
  break;

// --------------
case 'user_ban':
// --------------

  if ( $oVIP->role!='A' && $oVIP->role!='M' ) die(Error(12));
  if ( $s<2 ) die('Wrong parameters: user 0 and 1 cannot be banned');
  include(Translate('qtr_reg.php'));

  $oVIP->selfname = $L['Ban_user'];
  $oVIP->exiturl  = 'qtr_user.php?id='.$s;
  $oVIP->exitname = '&laquo; '.$L['Profile'];
  if ( $v=='adm' )
  {
      $oVIP->exiturl = 'qtr_adm_users.php';
      $oVIP->exitname = '&laquo; '.$L['Users'];
  }

  // ask delay
  if ( empty($ok) || $t<0 )
  {
    $oDB->Query('SELECT closed,name,photo FROM '.TABUSER.' WHERE id='.$s);
    $row = $oDB->Getrow();

    $oVIP->EndMessage
    (
    NULL,
    '<table class="hidden" cellspacing="0"><tr class="hidden">
    <td class="hidden">'.AsImgBox(AsImg( (empty($row['photo']) ? '' : QTR_DIR_PIC.$row['photo']),'',$row['name']),'picbox','',$row['name']).'</td>
    <td class="hidden">
    <form method="get" action="'.Href().'">
    <p style="text-align:right"><label for="t">'.$L['H_ban'].' </label><select id="t" name="t" size="1">
    <option value="0"'.($row['closed']=='0' ? QSEL : '').'>'.$L['N'].'</option>
    <option value="1"'.($row['closed']=='1' ? QSEL : '').'>1 '.$L['Day'].'</option>
    <option value="2"'.($row['closed']=='2' ? QSEL : '').'>10 '.$L['Days'].'</option>
    <option value="3"'.($row['closed']=='3' ? QSEL : '').'>20 '.$L['Days'].'</option>
    <option value="4"'.($row['closed']=='4' ? QSEL : '').'>30 '.$L['Days'].'</option>
    </select>&nbsp;
    <input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="hidden" name="v" value="'.$v.'"/>
    <input type="submit" name="ok" value="'.$L['Ok'].'"/></p>
    </form>
    </td>
    </tr>
    </table>',
    'admin',
    0,
    '500px'
    );

    exit;
  }

  // ban user
  if ( $t==-1 ) die('Wrong parameters: delay');
  $oDB->Query('UPDATE '.TABUSER.' SET closed="'.$t.'" WHERE id='.$s);

  // exit
  $oVIP->EndMessage(NULL,$L['S_update'],'admin',2);
  exit;
  break;

// --------------
case 'topicdelete':
// --------------

  if ( $oVIP->role!='A' && $oVIP->role!='M' ) die(Error(12));
  if ( $t<0 ) die('Wrong parameters: missing topic id');

  $oVIP->selfname = $L['Delete'].' '.$L['Topic'];
  $oVIP->exiturl = 'qtr_topics.php?s='.$s;
  $oVIP->exitname = '&laquo; '.$L['Section'];

  // ask confirmation
  if ( empty($ok) )
  {
    $oTopic = new cTopic($t);
    if ( $s<0 ) $s = $oTopic->parentid;
    $oVIP->exiturl = 'qtr_topics.php?s='.$s;
    if ( $oTopic->items==0 ) { $str=$L['None']; } else { $str=$oTopic->items.' <span class="small">('.$L['Last_message'].' '.QTdatestr($oTopic->lastpostdate).')</span>'; }

    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.Href().'">
    <table cellspacing="0" class="data_o">
    <tr class="data_o">
    <td class="colhd colhdfirst" style="width:150px;">'.$L['Title'].'</td>
    <td class="colct">'.$oTopic->GetTopicTitle().'</td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">'.$L['Topic_starter'].'</td>
    <td class="colct">'.$oTopic->firstpostname.' <span class="small">('.QTdatestr($oTopic->firstpostdate).')</span></td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">'.$L['Replys'].'</td>
    <td class="colct">'.$str.'</td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct"><input type="hidden" name="a" value="'.$a.'"/><input type="hidden" name="s" value="'.$s.'"/><input type="hidden" name="t" value="'.$t.'"/><input type="submit" name="ok" value="'.$L['Delete'].'"/></td>
    </tr>
    </table>
    </form>',
    $_SESSION[QT]['skin_dir'],
    0,
    '600px'
    );
    exit;
  }

  // delete topic
  if ( $t<0 ) die('Wrong parameters: missing topic id');
  $oDB->Query('DELETE FROM '.TABPOST.' WHERE topic='.$t);
  $oDB->Query('DELETE FROM '.TABTOPIC.' WHERE id='.$t);
  
  // update section stats
  UpdateSectionStats($s);

  // exit
  $oVIP->EndMessage(NULL,$L['S_delete'],$_SESSION[QT]['skin_dir'],2);
  exit;
  break;

// --------------
case 'topicmove':
// --------------

  if ( $oVIP->role!='A' && $oVIP->role!='M' ) die(Error(12));
  if ( $t<0 ) die('Wrong parameters: missing topic id');

  $oVIP->selfname = $L['Move'].' '.$L['Topic'];
  $oVIP->exiturl = 'qtr_topics.php?s='.$s;
  $oVIP->exitname = '&laquo; '.$L['Section'];

  // ask confirmation
  if ( empty($ok) || $p<0 )
  {
    $oTopic = new cTopic($t);
    if ( $oTopic->items==0 ) { $str=$L['None']; } else { $str=$oTopic->items.' <span class="small">('.$L['Last_message'].' '.QTdatestr($oTopic->lastpostdate).')</span>'; }

    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.Href().'">
    <table cellspacing="0" class="data_o">
    <tr class="data_o">
    <td class="colhd colhdfirst" style="width:150px;">'.$L['Title'].'</td>
    <td class="colct">'.$oTopic->GetTopicTitle().'</td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">'.$L['Topic_starter'].'</td>
    <td class="colct">'.$oTopic->firstpostname.' <span class="small">('.QTdatestr($oTopic->firstpostdate).')</span></td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">'.$L['Section'].'</td>
    <td class="colct">'.$oVIP->sections[$s].'</td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">'.$L['Replys'].'</td>
    <td class="colct">'.$str.'</td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst"><label for="p">'.$L['Move_to'].'</label></td>
    <td class="colct"><select id="p" name="p" size="1">'.Sectionlist(-1,$s).'</select></td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst"><label for="v">'.$L['Ref'].'</label></td>
    <td class="colct"><select id="v" name="v" size="1">
    <option value="1">'.$L['Move_keep'].'</option>
    <option value="0">'.$L['Move_reset'].'</option>
    <option value="2">'.$L['Move_follow'].'</option>
    </select></td>
    </tr>
    <tr class="data_o">
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct"><input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="hidden" name="t" value="'.$t.'"/>
    <input type="submit" name="ok" value="'.$L['Ok'].'"/></td>
    </tr>
    </table>
    </form>',
    $_SESSION[QT]['skin_dir'],
    0,
    '600px'
    );
    exit;
  }

  // move topic
  if ( $s<0 ) die('Wrong parameters section id');
  if ( $t<0 ) die('Wrong parameters id');
  if ( $p<0 ) die('Wrong parameters dest');
  if ( $v<0 ) die('Wrong parameters ref');
  $cSection::MoveItems($s,$p,$v,$t);
  UpdateSectionStats($p);
  UpdateSectionStats($s);

  // exit
  $oVIP->EndMessage(NULL,$L['S_update'],$_SESSION[QT]['skin_dir'],2);
  exit;
  break;

// --------------
case 'topicparam':
// --------------

  if ( !$oVIP->IsStaff() ) die($L['R_staff']);
  if ( $t<0 ) die('Wrong parameters: missing topic id');

  $oVIP->selfname = L('Inspection').' '.L('Parameters');
  $oVIP->exiturl = 'qtr_topic.php?s='.$s.'&amp;t='.$t;
  $oVIP->exitname = '&laquo; '.$L['Topic'];

  $oTopic = new cTopic($t);  
  if ( $oTopic->type!='I' ) { $oVIP->EndMessage(NULL,'Specific parameters cannot be confirgured.',$_SESSION[QT]['skin_dir'],2); exit; }

  $arr = $oTopic->ParamGet();
  
  // ask confirmation

  if ( empty($ok) )
  {
    if ( !isset($arr['Itype']) ) $arr['Itype'] = '0';
    if ( !isset($arr['Ilevel']) ) $arr['Ilevel'] = '3' ;
    if ( !isset($arr['Istat']) ) $arr['Istat'] = 'mean';
    $oVIP->EndMessage
    (
    NULL,
    '<form method="get" action="'.Href().'">
    <table cellspacing="0" class="data_o">
    <tr>
    <td class="colhd colhdfirst" style="width:150px;"><label for="v">'.$L['Status'].'</label></td>
    <td class="colct"><select id="v" name="v" size="1">'.QTasTag(array('0'=>L('I_closed'),'1'=>L('I_running')),$arr['Itype']).'</select></td>
    </tr>
    <tr>
    <td class="colhd colhdfirst"><label for="v1">'.L('I_level').'</label></td>
    <td class="colct"><select id="v1" name="v1" size="1">'.QTasTag(array('2'=>'2) '.L('I_r_yes').' / '.L('I_r_no'),'3'=>'3) '.L('I_r_good').' / '.L('I_r_medium').' / '.L('I_r_bad'),'5'=>'5) '.L('I_r_veryhigh').' / '.L('I_r_high').' / '.L('I_r_medium').' / '.L('I_r_low').' / '.L('I_r_verylow'),'100'=>'100) '.L('Percent')),$arr['Ilevel']).'</select></td>
    </tr>
    <tr>
    <td class="colhd colhdfirst"><label for="v2">'.L('I_aggregation').'</label></td>
    <td class="colct"><select id="v2" name="v2" size="1">'.QTasTag(array('mean'=>L('I_v_mean'),'min'=>L('I_v_min'),'max'=>L('I_v_max'),'first'=>L('I_v_first'),'last'=>L('I_v_last')),$arr['Istat']).'</select></td>
    </tr>
    <tr>
    <td class="colhd colhdfirst">&nbsp;</td>
    <td class="colct"><input type="hidden" name="a" value="'.$a.'"/>
    <input type="hidden" name="s" value="'.$s.'"/>
    <input type="hidden" name="t" value="'.$t.'"/>
    <input type="submit" name="ok" value="'.$L['Ok'].'"/></td>
    </tr>
    </table>
    </form>',
    $_SESSION[QT]['skin_dir'],
    0,
    '600px'
    );
    exit;
  }

  // save

  $arr = QTarradd($arr,'Itype',$v);
  $arr = QTarradd($arr,'Ilevel',$v1);
  $arr = QTarradd($arr,'Istat',$v2);
  $oTopic->ParamSet($arr);
  
  // activate inspection and recompute aggregation

  $oTopic->SetStatus(($arr['Itype']=='0' ? 'Z' : 'A'),false);
  if ( $oTopic->items>0 ) 
  {
    $oTopic->z = $oTopic->InspectionAggregate();
    $oDB->Query( 'UPDATE '.TABTOPIC.' SET z='.$oTopic->z.' WHERE id='.$oTopic->id );
  }

  // exit
  $oVIP->EndMessage(NULL,$L['S_update'],$_SESSION[QT]['skin_dir'],2);
  exit;
  break;
  
// --------------
case 'post':
// --------------

  $oVIP->selfname = $L['Message'];
  $oVIP->exiturl  = 'qtr_topic.php?s='.$s.'&amp;t='.$t;
  $oVIP->exitname = '&laquo; '.$L['Topic'];

  $oSEC = new cSection($s);
  $oTopic = new cTopic($t);
  $oPost = new cPost($p);

  echo $oHtml->Head();
  echo $oHtml->Body();

  HtmlPageCtrl(0,'90%');

  echo '
  <div class="msgboxpreview">

  <h2>',$oVIP->selfname,'</h2>
  ';
  $oPost->Show($oSEC,$oTopic,true,'','',$_SESSION[QT]['skin_dir'],'1');

  echo '
  </div>
  ';
  echo '<p><a id="exiturl" href="',Href($oVIP->exiturl),'">',$oVIP->exitname,'</a></p>';

  HtmlPageCtrl(1);

  echo $oHtml->End();

  exit;
  break;

// --------------
default:
// --------------

  echo 'Unknown action';
  break;

// --------------

}

$oVIP->EndMessage('!','Command ['.$a.'] failled...',$_SESSION[QT]['skin_dir'],2);