<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
if ( !$oVIP->CanView('V4') ) HtmlPage(11);
include('bin/qtr_fn_sql.php');

// INITIALISE

$strGroup = 'all';
$strOrder = 'name';
$strDirec = 'ASC';
$intLimit = 0;
$intPage = 1;

// Security check 1

if ( isset($_GET['group']) ) $strGroup = strip_tags($_GET['group']);
if ( isset($_GET['order']) ) $strOrder = strip_tags($_GET['order']);
if ( isset($_GET['dir']) ) $strDirec = strip_tags($_GET['dir']);
if ( isset($_GET['page']) ) $intPage = intval(strip_tags($_GET['page']));
if ( isset($_GET['view']) ) $_SESSION[QT]['viewmode'] = strip_tags($_GET['view']);

// Security check 2 (no long argument)

if ( strlen($strGroup)>4 ) die('Invalid argument #group');
if ( strlen($strOrder)>20 ) die('Invalid argument #order');
if ( strlen($strDirec)>4 ) die('Invalid argument #dir');

$intLimit = ($intPage-1)*$_SESSION[QT]['topics_per_page'];

$oVIP->selfurl = 'qtr_member.php';
$oVIP->selfname = $L['Memberlist'];

// MAP MODULE

if ( UseModule('map') ) { $strCheck='U'; include('qtrm_map_ini.php'); } else { $bMap=false; }

// COUNT

switch($strGroup)
{
Case 'all':   $strWhere = ''; Break;
Case '0':   $strWhere = ' AND '.FirstCharCase('name','a-z'); Break;
Default:   $strWhere = ' AND '.FirstCharCase('name','u').'="'.$strGroup.'"'; Break;
}

if ( $strGroup=='all' )
{
$intCount = $oVIP->members;
}
else
{
$oDB->Query('SELECT count(id) as countid FROM '.TABUSER.' WHERE id>0'.$strWhere);
$row = $oDB->Getrow();
$intCount = $row['countid'];
}

// GROUP LINE

if ( $intCount>$_SESSION[QT]['topics_per_page'] || isset($_GET['group']) ) $strGroups = HtmlLettres($strGroup,$L['All']);

// --------
// HTML START
// --------

include('qtr_p_header.php');

// Title and top participants

$str='';
$oDB->Query( LimitSQL('name, id, numpost FROM '.TABUSER.' WHERE id>0 AND numpost>0','numpost DESC',0,5) );
for ($i=0;$i<($_SESSION[QT]['viewmode']=='C' ? 2 : 5);$i++)
{
$row = $oDB->Getrow();
if ( !$row ) break;
$str .= '<tr class="hidden"><td class="hidden" style="text-align:left"><a href="'.Href('qtr_user.php').'?id='.$row['id'].'">'.$row['name'].'</a></td><td class="hidden" style="text-align:right">'.$row['numpost'].'</td></tr>'.PHP_EOL;
}
if ( !empty($str) ) $str = '<div class="legendbox"><p class="legendtitle">'.$L['Top_participants'].'</p><table class="hidden" cellspacing="0">'.$str.'</table></div>';

echo '<table class="hidden" cellspacing="0">
<tr class="hidden">
<td class="hidden"><h2>',$oVIP->selfname,'</h2><p>',($strGroup=='all' ? $oVIP->members.' '.$L['Users'] : $intCount.' / '.$oVIP->members.' '.$L['Users'] ),'</p></td>
<td class="hidden" style="width:170px;">',$str,'</td>
</tr>
</table>
';

// --------
// Button line and pager
// --------

$strPager = MakePager("qtr_member.php?group=$strGroup&order=$strOrder&dir=$strDirec",$intCount,$_SESSION[QT]['topics_per_page'],$intPage);
if ( !empty($strPager) ) $strPager = $L['Page'].$strPager;
if ( $intCount<$oVIP->members ) $strPager = '<span class="small">'.$intCount.' '.$L['Selected_from'].' '.$oVIP->members.' '.strtolower($L['Users']).'</span>'.(empty($strPager) ? '' : ' | '.$strPager);

if ( $oVIP->members>$_SESSION[QT]['topics_per_page'] ) echo '<table class="button" cellspacing="0" >',N,'<tr class="button">',N,$strGroups,'</tr>',N,'</table>',N,N;

if ( !empty($strPager) )
{
echo '<table class="hidden" cellspacing="0"><tr class="hidden"><td class="hidden" id="pager_zt">',$strPager,'</td></tr></table>',N,N;
}

// end if no result

if ( $intCount==0 ) { TableEmpty($L['None'].'...'); include('qtr_p_footer.php'); exit; }

// --------
// Memberlist
// --------

$bCompact = FALSE;
if ( $_SESSION[QT]['avatar']=='0' ) $bCompact = true;
if ( $_SESSION[QT]['viewmode']=='C' ) $bCompact = true;

echo '<table class="data_t" cellspacing="0" summary="users">',N;
echo '<tr class="data_t">',N;

// ========
$arrFLD = array();
if ( $bCompact )
{
$arrFLD['name'] = new cTableCell('name',$L['Username'],'colhd colhdfirst','width:150px','colct colfirst','','ASC');
}
else
{
$arrFLD['photo'] = new cTableCell('photo',$L['Avatar'],'colhd colhdfirst','width:100px','colct colfirst');
$arrFLD['name'] = new cTableCell('name',$L['Username'],'colhd','','colct','','ASC');
}
$arrFLD['role'] = new cTableCell('role',$L['Role'],'colhd','','colct','','ASC');
$arrFLD['contact'] = new cTableCell('contact',$L['Contact'],'colhd','','colct');
$arrFLD['location'] = new cTableCell('location',$L['Location'],'colhd','','colct','','ASC');
$arrFLD['numpost'] = new cTableCell('numpost',$L['Messages'],'colhd colhdlast center','','colct collast center','','DESC');
// ========
TableHeader($arrFLD,$intCount,"$oVIP->selfurl?group=$strGroup&amp;page=1",$strOrder,$strDirec);
// ========

echo '</tr>',N;

// ========
$strState = '* FROM '.TABUSER.' WHERE id>0'.$strWhere;
$oDB->Query( LimitSQL($strState,$strOrder.' '.$strDirec,$intLimit,$_SESSION[QT]['topics_per_page'],$intCount) );
// ========
$intWhile=0;
$strAlt='r1';
while($row=$oDB->Getrow())
{
  // privacy control for map and location field
  if ( $oVIP->IsPrivate($row['privacy'],$row['id']) ) { $row['y']=null; $row['x']=null; }

  TableRowShow($arrFLD,TableRowFormat($arrFLD,$row,null,null,$bMap),'data_t '.$strAlt);
  if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }
  if ( $bMap )
  {
    // map settings
    if ( !empty($row['x']) && !empty($row['y']) )
    {
      $str = $row['name'].'<br/><br/><a class="gmap" href="'.Href('qtr_user.php').'?id='.$row['id'].'">Open profile &raquo;<\/a>';
      if ( !empty($row['photo']) )
      {
      $str = '<table class="gmap"><tr><td>'.AsImg(QTR_DIR_PIC.$row['photo'],'',$row['name'],'imagelist').'<\/td><td>'.$str.'<\/td><\/tr><\/table>';
      }
      $oMapPoint = new cMapPoint( floatval($row['y']),floatval($row['x']),QTconv($row['name'],'-4'),$str );
      if ( isset($_SESSION[QT]['m_map_gsymbol']) )
      {
        $oMapPoint->icon = QTgetsymbol($row['role'],'icon');
        $oMapPoint->shadow = QTgetsymbol($row['role'],'shadow');
        $oMapPoint->printicon = QTgetsymbol($row['role'],'printicon');
        $oMapPoint->printshadow = QTgetsymbol($row['role'],'printshadow');
      }
      $arrExtData[intval($row['id'])] = $oMapPoint;
    }
  }
  $intWhile++;
  //odbcbreak
  if ( $intWhile>=$_SESSION[QT]['topics_per_page'] ) break;
}
// ========

echo '<tr class="data_t">',N;
echo '<td class="colft colftfirst"></td>',N;
for($i=0;$i<(count($arrFLD)-2);$i++) echo '<td class="colft"></td>',N;
echo '<td class="colft colftlast"></td>
</tr>
</table>
';

// -- Display pager --

if ( !empty($strPager) )
{
echo '<table class="button" cellspacing="0"><tr class="button"><td class="hidden" id="pager_zb">',$strPager,'</td></tr></table>',N,N;
}

// MAP MODULE, Show map

if ( $bMap )
{
  echo '<!-- Map module -->',N;
  if ( count($arrExtData)>0 )
  {
    $strMapHelp = sprintf($L['map']['items'],count($arrExtData),strtolower(LangS('User',$oVIP->members)) );

    if ( $bMapGoogle )
    {
      echo '<table class="hidden" style="margin-top:5px;">',N;
      echo '<tr class="hidden">',N;
      echo '<td class="gmap">',N;
      if ( !$_SESSION[QT]['m_map_hidelist'] )
      {
      echo QTgmapZoomControl($arrExtData);
      echo '<div id="map_canvas" style="width:100%; height:',($_SESSION[QT]['viewmode']=='C' ? '350' : '400'),'px;"></div>',N;
      }
      if ( !empty($strMapHelp) ) echo '<p class="gmap" style="margin:4px 0 0 0">'.$strMapHelp.'</p>';
      echo '</td>',N;
      echo '</tr>',N;
      echo '</table>',N;
    }

    if ( $bMapSitework )
    {
      if ( !$_SESSION[QT]['m_map_hidelist'] ) include('qtrm_sitework/mapapi.php');
    }

    // Show/Hide

    if ( $_SESSION[QT]['m_map_hidelist'] )
    {
    echo '<p style="margin:2px"><a href="',Href(),'?showmap">',$L['map']['Show_map'],'</a></p>',N;
    }
    else
    {
    echo '<p style="margin:2px"><a href="',Href(),'?hidemap">',$L['map']['Hide_map'],'</a></p>',N;
    }
  }
  else
  {
    echo '<p class="gmap">'.$L['map']['E_noposition'].'</p>',N;
  }
  echo '<!-- Map module end -->',N;
}

// --------
// HTML END
// --------

if ( $bMap )
{
  if ( count($arrExtData)>0 ) { include('qtrm_map_load.php'); } else { echo '<script type="text/javascript">function GUnload() { return true; }</script>'; }
}

include('qtr_p_footer.php');