<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
ob_end_clean();
require_once('bin/qtr_init.php');
require_once('bin/qtr_fn_sql.php');
require_once('bin/qt_lib_pdf.php');

if ( !$oVIP->CanView('V3') ) HtmlPage(11);

if ( !isset($_SESSION[QT]['editing']) ) $_SESSION[QT]['editing']=false;

$t = -1;
$tt = 'ticket';
QThttpvar('t tt','int str');
if ( $t<0 ) die('Missing topic id...');

// ---------
// PRE SETTINGS
// ---------

$bCanEdit = false;
$_SESSION[QT]['editing']=false;

CheckDico('tag tagdesc');

// --------
// INITIALISE
// --------

$oTopic = new cTopic($t,$oVIP->id);
$s = $oTopic->parentid;
$oSEC = new cSection($s);
$_SESSION[QT]['section']= $s; // previous section

  if ( $oSEC->type==1 && ($oVIP->role=='V' || $oVIP->role=='U') )
  {
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,Error(12),$_SESSION[QT]['skin_dir'],0);
  }
  if ( $oSEC->type==2 && $oVIP->role=='V' )
  {
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,Error(11),$_SESSION[QT]['skin_dir'],0);
  }

  if ( $oSEC->type==2 && $oVIP->role=='U' && $oTopic->firstpostuser != $oVIP->id )
  {
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,Error(11),$_SESSION[QT]['skin_dir'],0);
  }

$oTopic = new cTopic($t,$oVIP->id);
$oPost = new cPost($oTopic->firstpostid);

$strRef = '';
if ( $oTopic->numid >= 0 && $oSEC->numfield!='N' ) $strRef = sprintf($oSEC->numfield,$oTopic->numid);
if ( trim($oTopic->title)=='' ) $oTopic->title='('.strtolower($L['Reply']).')';
if ( empty($oTopic->title) && $oTopic->title!='0' ) $oTopic->title='('.strtolower($L['Reply']).')';

if ( $oTopic->type!='T' )
{
  // get only basic tabs in case of news/inspection topic
  $arrTabs = GetSectionTabs(-2);
  if ( isset($arrTabs['ticket']) )
  {
  if ( $oTopic->type=='A' ) { $arrTabs['ticket']->tabname=L('News'); $arrTabs['ticket']->tabdesc=L('News'); }
  if ( $oTopic->type=='I' ) { $arrTabs['ticket']->tabname=L('Inspection'); $arrTabs['ticket']->tabdesc=L('Inspection'); }
  }
}
else
{
  $arrTabs = GetSectionTabs($s);

  // add 'other' to the tabs (if $arrOtherTabs is not empty)
  $arr = $oTopic->GetDataTabs(array_keys($arrTabs));
  if ( count($arr)>0 )
  {
    $arrTabs['other'] = cTab::GetTab('other');
    // create a new list with the db-properties of the other tabs
    foreach($arr as $str)
    {
      $arrOtherTabs[$str] = cTab::GetTab($str);
    }
  }
}

$intLimit = 0;
$page = 1;
if ( isset($_GET['page']) ) { $intLimit = ($_GET['page']-1)*$_SESSION[QT]['replies_per_page']; $page=$_GET['page']; }
if ( isset($_GET['view']) ) { $_SESSION[QT]['viewmode'] = $_GET['view']; }

$oVIP->selfurl = 'qtr_topic.php';
$oVIP->exiturl = 'qtr_topics.php?s='.$s;
$oVIP->selfname = $L['Messages'];

// MAP MODULE

$bMap = UseModule('map');
if ( $bMap ) { if ( $tt!='ticket' && $tt!='gmap' ) $bMap=false; }
if ( $bMap ) { if ( empty($_SESSION[QT]['m_map_gkey']) ) $bMap=false; }

// TOPIC DESCRIPTION AND MAP

$strDescr = '';
$strLocation = '';

// --------
// PDF START
// --------

$pdf=new PDF();
$pdf->AliasNbPages();
$pdf->AddPage();
$pdf->SetTitle( ($strRef=='' ? '' : $strRef.' ').$oPost->title );
$pdf->SetAuthor( PdfClean($_SESSION[QT]['site_name']) );
$pdf->SetSubject( PdfClean(ObjTrans('sec',$oSEC->id,$oSEC->name)) );

// topic description

$strDescr = '';
if ( $_SESSION[QT]['section_desc']=='1' )
{
  if ( $oTopic->numid >= 0 && $oSEC->numfield!='N' )
  {
  $strDescr .= sprintf($oSEC->numfield,$oTopic->numid);
  if ( $oTopic->type=='T') $strDescr .= ' '.$oVIP->statuses[$oTopic->status]['statusname'];
  }
}
$pdf->SetFont('Arial','B',14);
$pdf->Write(10,( empty($strDescr) ? ' ' : PdfClean($strDescr)));
$pdf->Cell(0,10,PdfClean(ObjTrans('sec',$oSEC->id,$oSEC->name)),0,0,'R');

// --------
// TAB PRIMARY INFORMATION
// --------

$pdf->SetFont('Arial','B',14);
$pdf->SetTextColor(150);
$pdf->Ln();
$pdf->Cell(0, 10, (isset($_SESSION['L']['tabdesc']['ticket']) ? ObjTrans('tabdesc','ticket',false) : ObjTrans('tab','ticket')), 'T', 1, 'R');
$pdf->SetTextColor(0);
$pdf->SetFont('Arial','',11);

$iTabTop = $pdf->GetY();

$arrTable = array();
$iTextWidth = 0; if ( $_SESSION[QT]['viewmode']=='C' && $bMap ) $iTextWidth=85;

  // reference number

  if ( !empty($strRef) )
  {  
    $arrRow = array();
    $oCell = new cPdfCell($L['Ref'],45,6,'R',true); $oCell->font=array('Arial','B',11); $arrRow[]=$oCell;
    $oCell = new cPdfCell($strRef,$iTextWidth,6,'L'); $oCell->font=array('Arial','',11); $arrRow[]=$oCell;
    $arrTable[] = $arrRow;
  }

  // title

    $arrRow = array();
    $oCell = new cPdfCell($L['Title'],45,6,'R',true); $oCell->font=array('Arial','B',11); $arrRow[]=$oCell;
    $oCell = new cPdfCell($oPost->title,$iTextWidth,5,'L'); $oCell->font=array('Arial','B',11); $arrRow[]=$oCell;
    $arrTable[] = $arrRow;

  // message

    $arrRow = array();
    $oCell = new cPdfCell($L['Topic_desc'],45,6,'R',true); $oCell->font=array('Arial','B',11); $arrRow[]=$oCell;
    $oCell = new cPdfCell($oPost->text,$iTextWidth,5,'L'); $oCell->font=array('Arial','',11); $arrRow[]=$oCell;
    $arrTable[] = $arrRow;

  // eventdate

  if ( $oSEC->eventdate!='0' ) {
  if ( !empty($oTopic->eventdate) ) {
    $arrRow = array();
    $oCell = new cPdfCell($L['Eventdate'],45,6,'R',true); $oCell->font=array('Arial','B',11); $arrRow[]=$oCell;
    $oCell = new cPdfCell(QTdatestr($oTopic->eventdate,'$',($oTopic->eventdate>8 ? '$' : '')),$iTextWidth,6,'L'); $oCell->font=array('Arial','',11); $arrRow[]=$oCell;
    $arrTable[] = $arrRow;
  }}

  // status

  if ( isset($oVIP->statuses[$oTopic->status]['statusname']) )
  {
  $strTname = $oVIP->statuses[$oTopic->status]['statusname']; 
  }
  else
  {
  $strTname = 'unknown status'; 
  }
  
  $arrRow = array();
  $oCell = new cPdfCell($L['Status'],45,6,'R',true); $oCell->font=array('Arial','B',11); $arrRow[]=$oCell;
  $oCell = new cPdfCell($strTname,$iTextWidth,6,'L'); $oCell->font=array('Arial','',11); $arrRow[]=$oCell;
  $arrTable[] = $arrRow;
  
  
  // reported by

  $arrRow = array();
  $oCell = new cPdfCell($L['Topic_starter'],45,6,'R',true); $oCell->font=array('Arial','B',11); $arrRow[]=$oCell;
  $oCell = new cPdfCell($oTopic->firstpostname.', '.QTdatestr($oTopic->firstpostdate),$iTextWidth,6,'L'); $oCell->font=array('Arial','',11); $arrRow[]=$oCell;
  $arrTable[] = $arrRow;

  // tags

  $arrRow = array();
  $oCell = new cPdfCell($L['Tags'],45,6,'R',true); $oCell->font=array('Arial','B',11); $arrRow[]=$oCell;
  $oCell = new cPdfCell(str_replace(';',', ',$oTopic->tags),$iTextWidth,6,'L'); $oCell->font=array('Arial','',11); $arrRow[]=$oCell;
  $arrTable[] = $arrRow;
  
  // inspection result
  
  if ( $oTopic->type=='I' )
  {
  $arrRow = array();
  $str='';
  if ( !empty($oTopic->param) ) $str = ValueName($oTopic->z,$oTopic->ParamGet('Ilevel')).' ('.L('I_v_'.$oTopic->ParamGet('Istat')).', '.LangS('Reply',$oTopic->items).')';
  $oCell = new cPdfCell($L['Score'],45,6,'R',true); $oCell->font=array('Arial','B',11); $arrRow[]=$oCell;
  $oCell = new cPdfCell($str,$iTextWidth,6,'L'); $oCell->font=array('Arial','',11); $arrRow[]=$oCell;
  $arrTable[] = $arrRow;
  }

$pdf->BasicTable($arrTable);
if ( $oTopic->type=='I' )
{
$pdf->Image(ValueScalebar($oTopic->z,$oTopic->ParamGet('Ilevel'),50,false,true),55,$pdf->GetY()+0.2,20,5,'GIF');
}
$pdf->Ln(); if ( $pdf->GetY()>220 ) $pdf->AddPage();

// MAP MODULE

if ( $bMap ) {
if ( !empty($oTopic->y) && !empty($oTopic->x) ) {

  $y = floatval($oTopic->y);
  $x = floatval($oTopic->x);
  switch(substr($_SESSION[QT]['m_map_gbuttons'],0,1))
  {
  case 'S': $strMapType = 'satellite'; break;
  case 'H': $strMapType = 'hybrid'; break;
  case 'P': $strMapType = 'terrain'; break;
  default:  $strMapType = 'roadmap'; break;
  }  
  if ( $_SESSION[QT]['viewmode']=='C' && $bMap )
  {
    if ( $pdf->GetY()<$iTabTop+48 ) $pdf->SetY($iTabTop+48);
    $strUrl = 'http://maps.google.com/staticmap?center='.$y.','.$x.'&zoom='.$_SESSION[QT]['m_map_gzoom'].'&size=250x200&maptype='.$strMapType.'&markers='.$y.','.$x.'&key='.$_SESSION[QT]['m_map_gkey'];
    $pdf->Image($strUrl,140,$iTabTop,60,48,'GIF');
  }
  else
  {
    $strUrl = 'http://maps.google.com/staticmap?center='.$y.','.$x.'&zoom='.$_SESSION[QT]['m_map_gzoom'].'&size=400x200&maptype='.$strMapType.'&markers='.$y.','.$x.'&key='.$_SESSION[QT]['m_map_gkey'];
    $pdf->Image($strUrl,10,$pdf->GetY(),170,85,'GIF');
    $pdf->SetY($pdf->GetY()+85);
  }

}}

// --------
// TAB DATAS
// --------

foreach($arrTabs as $tt=>$arrTab)
{
  if ( $tt=='ticket' || $tt=='documents' || $tt=='messages' ) continue;

  // tab 
  
  $pdf->SetFont('Arial','B',14);
  $pdf->SetTextColor(150);
  $pdf->Ln();  if ( $pdf->GetY()>220 ) $pdf->AddPage();
  $pdf->Cell(0, 10, PdfClean((isset($_SESSION['L']['tabdesc'][$tt]) ? ObjTrans('tabdesc',$tt,false) : ObjTrans('tab',$tt))), 'T', 1, 'R');
  $pdf->Ln(2);
  $pdf->SetTextColor(0);
  $pdf->SetFont('Arial','',11);

  // initialise
  
  CheckDico('field',true);
  
  $arrFields = array();
    if ( $oVIP->role=='U' || $oVIP->role=='V' ) { $strWhere = ' AND fieldselect="1"'; } else { $strWhere=''; }
    $oDB->Query('SELECT * FROM '.TABFIELD.' WHERE tabid="'.$tt.'"'.$strWhere.' ORDER by fieldorder');
    while($row=$oDB->Getrow())
    {
      $strField = $row['fieldid'];
      $arrFields[$strField] = $row;
    }
  
  $arrDatas = array();
    $oDB->Query( 'SELECT fieldid,fieldvalue FROM '.TABDATA.' WHERE tabid="'.$tt.'" AND id='.$t );
    while($row=$oDB->Getrow()) $arrDatas[$row['fieldid']] = $row['fieldvalue'];

  $arrTable = array();

  // show fields
  
  foreach($arrFields as $strField =>$arrField)
  {
    $strValue = ( isset($arrDatas[$strField]) ? $arrDatas[$strField] : '' );
    $strDesc = ObjTrans('fielddesc',$strField,false);

    $arrRow = array();
    $oCell = new cPdfCell(ObjTrans('field',$strField),45,6,'R',true); $oCell->font=array('Arial','B',11); $arrRow[]=$oCell;
    $oCell = new cPdfCell((strlen($strValue)==0 ? ' ' : $strValue),100,6,'L'); $oCell->font=array('Arial','',11); $arrRow[]=$oCell;
    if ( !empty($strDesc) )
    {
    $oCell = new cPdfCell($strDesc,0,4,'L'); $oCell->font=array('Arial','',9); $arrRow[]=$oCell;
    }
    $arrTable[] = $arrRow;
  }
  $pdf->BasicTable($arrTable);
}

// --------
// TAB MESSAGES
// --------

$pdf->SetFont('Arial','B',14);
$pdf->SetTextColor(150);
$pdf->Ln(); if ( $pdf->GetY()>200 ) $pdf->AddPage();
$pdf->Cell(0, 10, PdfClean((isset($_SESSION['L']['tabdesc']['messages']) ? ObjTrans('tabdesc','messages',false) : ObjTrans('tab','messages'))), 'T', 1, 'R');
$pdf->Ln(2);
$pdf->SetTextColor(0);
$pdf->SetFont('Arial','',11);


  // COUNT RECORDS

  $oDB->Query('SELECT count(p.id) as countid FROM '.TABPOST.' p WHERE p.section='.$oSEC->id.' AND p.topic='.$oTopic->id);
  $row = $oDB->Getrow();
  $intPosts = $row['countid'];

  // stop if no post (or user not creator)

  if ( $intPosts==0 )
  {
    $pdf->Write(6, $L['None'].'...');
  }
  else
  {
    // QUERY

    $strState = 'p.id,p.section,p.topic,p.icon,p.title,p.type,p.userid,p.username,p.issuedate,p.modifdate,p.modifuser,p.modifname,p.attach,p.textmsg, u.role, u.location, u.photo, u.signature
    FROM '.TABPOST.' p, '.TABUSER.' u WHERE p.userid = u.id AND p.topic='.$oTopic->id;
    $strQuery = LimitSQL($strState,'p.id ASC',$intLimit,10);
    $oDB->Query($strQuery);

    $iMsgNum = $intLimit;
    $iMsgAdd = 1;
    $pdf->SetDrawColor(240); 
    
    // DISPLAY MESSAGES

    while($row=$oDB->Getrow())
    {
      // READ DATA

      $arrTable = array(); 
      $iYrow = $pdf->GetY(); if ( $iYrow>220 ) { $pdf->AddPage(); $iYrow = $pdf->GetY(); }

      $iMsgNum = $iMsgNum + $iMsgAdd;
      $oPost = new cPost($row,$iMsgNum);
    
      // PRE PROCESSING DATA
      
      if ( $_SESSION[QT]['viewmode']=='C' )
      {
      $oPost->text = QTcompact($oPost->text);
      }
    
      $strEndLine = '';
      if ( !empty($oPost->modifuser) )
      {
      $strEndLine = $L['Modified_by'].' '.$oPost->modifname.' ('.QTdatestr($oPost->modifdate,'$','$').')';
      }
      
      // prepare icon

      if ( $oPost->type=='P' )
      {
        if ( strtolower($oTopic->type)=='a' )
        {
          $strIcon = $_SESSION[QT]['skin_dir'].'/ico_topic_a_0.gif';
        }
        else
        {
          if ( isset($oVIP->statuses[$oTopic->status]['statusname']) )
          {
          $strIcon = $_SESSION[QT]['skin_dir'].'/'.$oVIP->statuses[$oTopic->status]['icon'];
          }
          else
          {
          $strIcon = 'admin/ico_status.gif/ico_topic_a_0.gif';
          }
        }
      }
      else
      {
        $strIcon = $_SESSION[QT]['skin_dir'].'/ico_post_'.strtolower($oPost->type).'.gif';
      }

      // prepare title

      if ( $oPost->type=='D' )
      {
        $strTitle = $L['Message_deleted'].' ('.$oPost->text.')';
      }
      else
      {
        $strTitle = $oPost->title;
        if ( $oTopic->type=='I' ) $strTitle = $oPost->GetScoreName($oTopic);
        if ( !empty($oSEC->wisheddate) && $oTopic->wisheddate>0 )
        {
        $strTitle .= ' '.$L['Wisheddate'].': '.QTdatestr($oTopic->wisheddate,'$','');
        }
      }

      // message title

      $arrRow = array();
      $oCell = new cPdfCell(' ',10,6,'',true); $arrRow[]=$oCell;
      $oCell = new cPdfCell($strTitle,125,6,'L',true); $oCell->font=array('Arial','B',11); $arrRow[]=$oCell;
      $oCell = new cPdfCell(QTdatestr($oPost->issuedate,'$','$').( $oPost->num>=0 ? ' ['.$oPost->num.']' : ''),0,6,'R',true); $oCell->font=array('Arial','',11); $arrRow[]=$oCell;
      $arrTable[] = $arrRow;

      // incident date

      if ( $oPost->type=='P' ) {
      if ( !empty($oSEC->eventdate) && !empty($oTopic->eventdate) ) {

      $arrRow = array();
      $oCell = new cPdfCell(' ',20,6); $arrRow[]=$oCell;
      $oCell = new cPdfCell( QTdatestr($oTopic->eventdate,'$',(strlen($oTopic->eventdate)>8 ? '$' : '')),40,6,'L' ); $oCell->font=array('Arial','B',11); $arrRow[]=$oCell;
      $oCell = new cPdfCell('('.$L['Eventdate'].')',0,6,'L'); $oCell->font=array('Arial','',9); $arrRow[]=$oCell;
      $arrTable[] = $arrRow;
   
      }}

      // message

      if ( $oPost->type!='D' )
      {
        $arrRow = array();
        $oCell = new cPdfCell(' ',10,6); $arrRow[]=$oCell;
        $oCell = new cPdfCell(QTcompact(QTunbbc($oPost->text),0,( $_SESSION[QT]['viewmode']=='C' ? ' ' : "\n")),148,4.5,'L'); $oCell->font=array('Arial','',11); $arrRow[]=$oCell;
        $arrTable[] = $arrRow;
        // signature
        if ( $_SESSION[QT]['viewmode']!='C' ) {
        if ( $oPost->type!='F' && $oTopic->type!='I' ) {
        if ( !empty($oPost->usersign) ) {
          $arrRow = array();
          $oCell = new cPdfCell(' ',10,6); $arrRow[]=$oCell;
          $oCell = new cPdfCell(QTbbc($oPost->usersign),148,5,'L'); $oCell->font=array('Arial','BI',9); $arrRow[]=$oCell;
          $arrTable[] = $arrRow;
        }}}
        // modified
        if ( !empty($oPost->modifuser) )
        {
          $arrRow = array();
          $oCell = new cPdfCell(' ',10,6); $arrRow[]=$oCell;
          $oCell = new cPdfCell($L['Modified_by'].' '.$oPost->modifname.' '.QTdatestr($oPost->modifdate,'$','$'),150,1.5,'L'); $oCell->font=array('Arial','',9); $arrRow[]=$oCell;
          $arrTable[] = $arrRow;
        }
      }
      
      // SHOW MESSAGE
      
      $pdf->BasicTable($arrTable); $iEndTable = $pdf->GetY();
      
      $pdf->Image($strIcon,11,$iYrow+0.5);
      if ( $oPost->icon!='00' ) $pdf->Image($_SESSION[QT]['skin_dir'].'/ico_prefix_'.$oSEC->prefix.'_'.$oPost->icon.'.gif',11,$iYrow+8);
      if ( $oTopic->type=='I' )
      {
        $i = $oPost->GetScore($oTopic);
        if ( $i>=0 )  $pdf->Image(ValueScalebar($i,$oTopic->ParamGet('Ilevel'),50,false,true),70,$iYrow+0.5);
      }

      if ( $oPost->type=='P' ) {
      if ( !empty($oSEC->eventdate) && !empty($oTopic->eventdate) ) {
      $pdf->Image($_SESSION[QT]['skin_dir'].'/ico_topic_date.gif',21,$iYrow+7);
      }}
      
      $pdf->SetXY(166,$iYrow+7);
      if ( $_SESSION[QT]['viewmode']!='C' && !empty($oPost->useravat) ) $pdf->Image(QTR_DIR_PIC.$oPost->useravat);
      $pdf->Cell(0,6, '('.PdfClean($oPost->username).')',1,1,'C');
      $iEndImage = $pdf->GetY();
      $pdf->SetY(max($iEndTable,$iEndImage));

      $pdf->Ln(2);   

    }
    $pdf->SetDrawColor(0); 
  }

// --------
// TAB DOCUMENTS
// --------

$arrDocs = array();
$oDB->Query('SELECT docname,docfile,docpath,docdate FROM '.TABDOC.' WHERE id='.$t.' ORDER by docdate ASC');
while($row=$oDB->Getrow()) $arrDocs[$row['docfile']] = $row;

// --------
if ( count($arrDocs)>0 ) {
// --------

// PAGE BREAK

$pdf->AddPage();

// PAGE TAB

$pdf->SetFont('Arial','B',14);
$pdf->SetTextColor(150);
$pdf->Ln();
$pdf->Cell(0, 10, PdfClean((isset($_SESSION['L']['tabdesc']['documents']) ? ObjTrans('tabdesc','documents',false) : ObjTrans('tab','messages'))), 'T', 1, 'R');
$pdf->Ln(2);
$pdf->SetTextColor(0);
$pdf->SetFont('Arial','',11);

// SHOW DOCS

  $bStart=true;
  $yTop=$pdf->GetY();
  foreach($arrDocs as $intDoc =>$arrDoc)
  {
    // check file exists
    if ( file_exists($arrDoc['docpath'].$arrDoc['docfile']) )
    {  
      $strExt = substr(strrchr($arrDoc['docfile'],'.'),1);
      if ( in_array($strExt,array('gif','jpg','jpeg','png')) )
      {
      $str = $arrDoc['docpath'].$arrDoc['docfile'];
      $bCanGrow = true;
      }
      else
      {
      $str = $_SESSION[QT]['skin_dir'].'/qtr_document.gif';
      $bCanGrow = false;
      }
      $strName = PdfClean((!empty($arrDoc['docname']) ? $arrDoc['docname'] : $arrDoc['docfile']));
      $strDate = PdfClean((!empty($arrDoc['docdate']) ? ' ('.QTdatestr($arrDoc['docdate'],'$','$').')' : ' '));
      
      if ( $_SESSION[QT]['viewmode']=='C' )
      {
        if ( $bStart )
        {
        $pdf->Image($str,10,$yTop,($bCanGrow ? 30 : 0));
        $yBot = $yTop;
        $pdf->SetXY(45,$yTop); $pdf->Cell(40,5,$strName);
        $pdf->SetXY(45,$yTop+5); $pdf->Cell(40,5,$strDate);
        }
        else
        {
        $pdf->Image($str,100,$yTop,($bCanGrow ? 30 : 0)); 
        if ( $bCanGrow ) { $yBot += 32; } else  {$yBot +=15; }
        $pdf->SetXY(135,$yTop); $pdf->Cell(40,5,$strName);
        $pdf->SetXY(135,$yTop+5); $pdf->Cell(40,5,$strDate);
        }
      }
      else
      {
        $pdf->Image($str,10,$yTop,($bCanGrow ? 70 : 0));
        if ( $bCanGrow ) { $yBot = $yTop+70; } else  { $yBot = $yTop+15; }
        $pdf->SetXY(100,$yTop); $pdf->Cell(40,5,$strName);
        $pdf->SetXY(100,$yTop+5); $pdf->Cell(40,5,$strDate);
      }
      $yTop = $yBot;
      $bStart=!$bStart;  
    }
  }

// --------
}
// --------

// --------
// PDF END
// --------
$pdf->Output();

?>