<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
if ( !$oVIP->CanView('V2') ) HtmlPage(11);
include('bin/qtr_fn_sql.php');

$s = -1; QThttpvar('s','int'); if ( $s<0 ) die('Missing section id...');

// ---------
// SUBMITTED
// ---------

if ( isset($_POST['m-ok']) )
{
  if ( $_POST['Maction']=='nt' ) $oHtml->Redirect('qtr_form_edit.php?s='.$s.'&amp;a=nt',$L['Post_new_topic']);
  if ( $_POST['Maction']=='show_Z' ) $_SESSION[QT]['show_closed']='1';
  if ( $_POST['Maction']=='hide_Z' ) $_SESSION[QT]['show_closed']='0';
  if ( $_POST['d_last']==='-' || $_POST['d_last']==='' ) { unset($_SESSION[QT]['lastcolumn']); } else { $_SESSION[QT]['lastcolumn']=$_POST['d_last']; } // can be '0' (none)
}

// ---------
// INITIALISE
// ---------

$_SESSION[QT]['section']= $s; // previous section

$oSEC = new cSection($s);
if ( isset($_SESSION[QT]['lastcolumn']) ) $oSEC->d_last=$_SESSION[QT]['lastcolumn'];
if ( $oSEC->type==1 && ($oVIP->role=='V' || $oVIP->role=='U') )
{
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,Error(12),$_SESSION[QT]['skin_dir'],0);
}
if ( $oSEC->type==2 && $oVIP->role=='V' )
{
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,Error(11),$_SESSION[QT]['skin_dir'],0);
}

$oVIP->selfurl = 'qtr_topics.php';
$oVIP->selfname = $oSEC->name; 

$strCommand = '';
$numid = '';

$strOrder = $oSEC->d_order; //lastpostdate
if ( $strOrder=='title' ) { $strDirec='ASC'; } else { $strDirec='DESC'; }
$page = 1;
$intLimit = 0;
if ( isset($_GET['page']) ) { $intLimit = (intval($_GET['page'])-1)*$_SESSION[QT]['topics_per_page']; $page = intval($_GET['page']); }
if ( isset($_GET['order']) ) $strOrder = $_GET['order'];
if ( isset($_GET['dir']) ) $strDirec = $_GET['dir'];

if ( QTR_LIST_ME && $oVIP->numpost>0 )
{
  $oDB2 = new cDB($qtr_dbsystem,$qtr_host,$qtr_database,$qtr_user,$qtr_pwd,$qtr_port,$qtr_dsn);
}

// Criteria sql: topics visible for current user ONLY

$strWhere = '';
if ( $oSEC->type==2 && !$oVIP->IsStaff() ) $strWhere .= ' AND (t.firstpostuser='.$oVIP->id.' OR t.type="A")';
if ( $_SESSION[QT]['show_closed']=='0' ) $strWhere.=' AND t.status<>"Z"';
$strOnTop = '';
if ( $_SESSION[QT]['news_on_top']==1 )
{ 
  $strOnTop = 'CASE t.type WHEN "A" THEN "A" ELSE "Z" END as typea,';
}

// Count topics visible for current user ONLY

$oDB->Query( 'SELECT count(*) as countid FROM '.TABTOPIC.' t WHERE t.section='.$oSEC->id.$strWhere );
$row = $oDB->Getrow();
$oSEC->items = intval($row['countid']);

// MAP MODULE

if ( UseModule('map') ) { $strCheck=$s; include('qtrm_map_ini.php'); } else { $bMap=false; }

// --------
// HTML START
// --------

$strHeadScript = '<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript">
<!--
$(document).ready(function() {
  $(".tag").hover(function() {
    var oTag = $(this);
    $.post("qtr_j_tag.php",{s:oTag.attr("title"),val:oTag.html(),lang:"'.GetIso().'",na:""}, function(data) { oTag.attr({title:data}); } );
    });
  });
-->
</script>
';

include('qtr_p_header.php');

// STAFF MENU

if ( $oVIP->IsStaff() )
{
echo '
<form method="post" action="',Href('qtr_topics.php'),'?s=',$s,'" id="m-form">
<div class="modboard">
<span class="modboard"><label for="Maction">',$L['Userrole'][$oVIP->role],' </label><input type="hidden" name="s" value="',$oSEC->id,'"/>
<select id="Maction" name="Maction" class="small" onchange="document.getElementById(\'m-ok\').click();">
<option value="">&nbsp;</option>
<option value="nt">',$L['Post_new_topic'],'...</option>
<option value="" disabled="disabled">---------------</option>
<option value="show_Z"',($_SESSION[QT]['show_closed'] ? ' class="bold"' : ''),'>',$L['Topic_closed_show'],'</option>
<option value="hide_Z"',(!$_SESSION[QT]['show_closed'] ? ' class="bold"' : ''),'>',$L['Topic_closed_hide'],'</option>
</select> &nbsp;<label for="d_last">',$L['Last_column'],S,'</label>
<select id="d_last" name="d_last" class="small" onchange="document.getElementById(\'m-ok\').click();">
<option value="-">&nbsp;</option>';
echo QTasTag( array('views'=>$L['Views'],'eventdate'=>$L['Eventdate'],'wisheddate'=>$L['Wisheddate'],'status'=>$L['Status'],'actorname'=>$L['Userrole_MA'],'notifiedname'=>$L['Userrole_UN'],'tags'=>$L['Tags']),'',array('current'=>$oSEC->d_last,'classC'=>'bold') );
echo '<option value="-" disabled="disabled">---------------</option>
<option value="0"',($oSEC->d_last=='0' ? ' class="bold"' : ''),'>(',$L['None'],')</option>
<option value="-" disabled="disabled">---------------</option>
<option value="id">Id</option>
<option value="modifdate">',$L['Modified'],'</option>
';
if ( $bMap ) echo '<option value="coord" class="small">',$L['Coord'],'</option>
';
echo '
</select> <input type="submit" name="m-ok" value="',$L['Ok'],'" class="small" id="m-ok"/>
<script type="text/javascript">document.getElementById("m-ok").style.display="none";</script>
</span>
</div>
</form>
';
}

// SECTION DESCRIPTION

if ( $_SESSION[QT]['section_desc']=='1' ) {
if ( !empty($oSEC->descr) ) {
  echo '<!-- Section description --><p id="sectiondesc">',$oSEC->descr,'</p>',PHP_EOL;
}}

// BUTTONS AND PAGER

if ( $oSEC->status==1 )
{
  $strCommand = '<td class="button" style="width:120px"><span class="button_off">&nbsp;'.$L['E_section_closed'].'&nbsp;</span></td>';
}
else
{
  $strCommand = '<td class="button" style="width:120px">&nbsp;<a class="button" href="'.Href('qtr_form_edit.php?s='.$oSEC->id.'&amp;a=nt').'">'.$L['Post_new_topic'].'</a>&nbsp;</td>';
  if ( $oVIP->role=='V' && $_SESSION[QT]['visitor_right']<7 )
  {
  $strCommand = '<td class="button" style="width:120px"><span class="button_off">&nbsp;'.$L['Post_new_topic'].'&nbsp;</span></td>';
  }
}
$strCommand .= ( $oSEC->items<3 || $_SESSION[QT]['board_offline']=='1' || ($oVIP->role=='V' && $_SESSION[QT]['visitor_right']<5) ? '' : '<td class="button" style="width:30px"><span class="button">&nbsp;'.AsImg($_SESSION[QT]['skin_dir'].'/ico_search.gif','Search',$L['Search'],'ico i_topic','','qtr_search.php?s='.$s).'&nbsp;</span></td>' );
$strPager = MakePager("$oVIP->selfurl?s=$oSEC->id&amp;order=$strOrder&amp;dir=$strDirec",$oSEC->items,$_SESSION[QT]['topics_per_page'],$page);
if ( $strPager!='' ) $strPager = $L['Page'].$strPager;
$strCommand = ( QTR_BACKBUTTON ? '<td class="button" style="width:20px"><a href="'.Href($oVIP->exiturl).'" class="button">'.QTR_BACKBUTTON.'</a></td>' : '').$strCommand.'<td></td>';

echo '
<!-- Button and pager -->
<table class="button button_top" cellspacing="0">
<tr class="button">
',$strCommand,'<td id="pager_zt">',$strPager,'</td>
</tr>
</table>
';

// End if no results

if ( $oSEC->items==0 ) { TableEmpty($L['E_no_topic'].'...'); include('qtr_p_footer.php'); exit; }

// --------
// Prepare fields
// --------

switch($oSEC->d_last)
{
case 'replies': $str=$L['Replys']; break;
case 'views': $str=$L['Views']; break;
case 'status': $str=$L['Status']; break;
case 'wisheddate': $str=$L['Wisheddate']; break;
case 'eventdate': $str=$L['Eventdate']; break;
case 'id': $str='Id'; break;
case 'actorname': $str=$L['Userrole_MA']; break;
case 'notifiedname': $str=$L['Userrole_UN']; break;
case 'tags': $str=$L['Tags']; break;
case 'coord': $str=$L['Coord']; break;
default: $str=$oSEC->d_last;
}

$arrFLD = array();
$arrFLD['icon'] = new cTableCell('icon','&bull;','colhd colhdico colhdfirst','','colct colico colfirst','','ASC'); $arrFLD['icon']->uid='status';
if ( $oSEC->numfield!='N' ) $arrFLD['numid'] = new cTableCell('numid',$L['Ref'],'colhd colhdref','','colct colref','','DESC');
if ( !empty($oSEC->prefix) ) $arrFLD['smile'] = new cTableCell('smile','&nbsp;','colhd colhdsmi','','colct colsmi');
$arrFLD['title'] = new cTableCell('title',$L['Topics'],'colhd','','colct','','DESC');
if ( QTR_LIST_ME ) $arrFLD['you'] = new cTableCell('you','&nbsp;','colhd','width:10px','colct');
$arrFLD['firstpostname'] = new cTableCell('firstpostname',$L['Author'],'colhd','width:140px','colct','','ASC');
$arrFLD['lastpostdate'] = new cTableCell('lastpostdate',$L['Last_message'],'colhd','width:140px','colct','','ASC');
if ( $oSEC->d_last=='none' || empty($oSEC->d_last) || $oSEC->d_last=='N' || $oSEC->d_last=='replies' )
{
$arrFLD['replies'] = new cTableCell('replies',$L['Replys'],'colhd center colhdlast','width:75px','colct center collast','','DESC');
}
else
{
$arrFLD['replies'] = new cTableCell('replies',$L['Replys'],'colhd center','width:75px','colct center','','DESC');
$arrFLD[$oSEC->d_last] = new cTableCell($oSEC->d_last,$str,'colhd center colhdlast','width:80px','colct center collast','',($oSEC->d_last=='tags' ? FALSE : 'ASC'));
}
if ( isset($arrFLD['numid']) || isset($arrFLD['status']) )
{
$arrStatusStyles=array();
foreach($oVIP->statuses as $id=>$arrStatus) if ( !empty($arrStatus['color']) ) $arrStatusStyles[$id]=$arrStatus['color'];
if ( isset($arrFLD['status']) ) $arrFLD['status']->style_dynamic=array('background-color:%s','status',$arrStatusStyles);
if ( isset($arrFLD['numid']) ) $arrFLD['numid']->style_dynamic=array('background-color:%s','status',$arrStatusStyles);
}

// --------
// DISPLAY TOPICS
// --------

echo '
<!-- List of tickets -->
<table class="data_t" cellspacing="0" summary="tickets">
<thead>
<tr class="data_t">'; TableHeader($arrFLD,$oSEC->items,$oVIP->selfurl.'?'.GetURI('order,dir'),$strOrder,$strDirec); echo '</tr>
</thead>
<tfoot>
<tr class="data_t"><td class="colft colftfirst"></td>'; for($i=0;$i<(count($arrFLD)-2);$i++) echo '<td class="colft"></td>'; echo '<td class="colft colftlast"></td></tr>
</tfoot>
<tbody>
';

$strState = $strOnTop.'t.*,p.title,p.icon,p.textmsg FROM '.TABTOPIC.' t INNER JOIN '.TABPOST.' p ON t.firstpostid=p.id WHERE t.section = '.$oSEC->id.$strWhere;
if ( $strOrder=='title' ) { $strFullOrder='p.title'; } else { $strFullOrder='t.'.$strOrder; }
$oDB->Query( LimitSQL($strState,(empty($strOnTop) ? '' : 'typea ASC, ').$strFullOrder.' '.$strDirec,$intLimit,$_SESSION[QT]['topics_per_page'],$oSEC->items) );
$intWhile=0;
$strAlt='r1';
while($row=$oDB->Getrow())
{
  TableRowShow($arrFLD,TableRowFormat($arrFLD,$row,true,$oSEC,$bMap),'data_t '.$strAlt,$row);
  if ( $strAlt=='r1' ) { $strAlt='r2'; } else { $strAlt='r1'; }

  $intWhile++; 
  //odbcbreak
  if ( $intWhile>=$_SESSION[QT]['topics_per_page'] ) break;  
}

echo '</tbody>
</table>
';

// BUTTON LINE AND PAGER

// define csv options according to $oSEC->items (max 10000)

$strCsv = '';
$strCalendar = '';

// calendar
if ( $oVIP->CanViewCalendar() )
{
  $strCalendar = '<a class="tablecommand csv" href="'.Href('qtr_calendar.php').'?s='.$s.'" title="Calendar view">Calendar view</a>';
}

if ( $oVIP->role!='V' )
{
  if ( $oSEC->items<=$_SESSION[QT]['topics_per_page'] )
  {
  $strCsv = '<a href="'.Href('qtr_topics_csv.php').'?s='.$s.'&amp;size=all&amp;n='.$oSEC->items.'&amp;order='.$strOrder.'&amp;dir='.$strDirec.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].'</a>';
  }
  else
  {
  $strCsv = '<a href="'.Href('qtr_topics_csv.php').'?s='.$s.'&amp;size=p'.$page.'&amp;n='.$oSEC->items.'&amp;order='.$strOrder.'&amp;dir='.$strDirec.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' ('.strtolower($L['Page']).')</a>';
  if ( $oSEC->items<=1000 )                      $strCsv .= ' &middot; <a href="'.Href('qtr_topics_csv.php').'?s='.$s.'&amp;size=all&amp;n='.$oSEC->items.'&amp;order='.$strOrder.'&amp;dir='.$strDirec.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' ('.strtolower($L['All']).')</a>';
  if ( $oSEC->items>1000 && $oSEC->items<=2000 ) $strCsv .= ' &middot; <a href="'.Href('qtr_topics_csv.php').'?s='.$s.'&amp;size=m1&amp;n='.$oSEC->items.'&amp;order='.$strOrder.'&amp;dir='.$strDirec.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' (1-1000)</a> &middot; <a href="'.Href('qtr_topics_csv.php').'?s='.$s.'&amp;size=m2&amp;n='.$oSEC->items.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' (1000-'.$oSEC->items.')</a>';
  if ( $oSEC->items>2000 && $oSEC->items<=5000 ) $strCsv .= ' &middot; <a href="'.Href('qtr_topics_csv.php').'?s='.$s.'&amp;size=m5&amp;n='.$oSEC->items.'&amp;order='.$strOrder.'&amp;dir='.$strDirec.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' (1-5000)</a>';
  if ( $oSEC->items>5000 )                       $strCsv .= ' &middot; <a href="'.Href('qtr_topics_csv.php').'?s='.$s.'&amp;m=5&amp;n='.$oSEC->items.'&amp;order='.$strOrder.'&amp;dir='.$strDirec.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' (1-5000)</a> &middot; <a href="'.Href('qtr_topics_csv.php').'?s='.$s.'&amp;m=10&amp;n='.$oSEC->items.'" class="csv" title="'.$L['H_Csv'].'">'.$L['Csv'].' (5000-10000)</a>';
  }
}
if ( !empty($strCsv) )
{
  $strPager = $strCsv.' &middot; '.$strPager;
}
if ( !empty($strCalendar) )
{
  $strPager = $strCalendar.' &middot; '.$strPager;
}
if ( substr($strPager,-10,10)==' &middot; ' ) $strPager = substr($strPager,0,-10);

if ( $oSEC->items>2 )
{
echo '<table class="button button_bot" cellspacing="0"><tr class="button">',$strCommand,'<td id="pager_zb">&nbsp;',$strPager,'</td></tr></table>
';
}
else
{
echo '<p id="pager_zb" class="csv">&nbsp;',$strPager,'</p>';
}

// TAGS FILTRING

if ( QTR_LIST_TAG && !empty($_SESSION[QT]['tags']) )
{
  require_once('bin/qtr_fn_tags.php');
  $arrTags = $oSEC->GetTagsUsed($s,50);
  if ( count($arrTags)>0 ) 
  {
    if ( count($arrTags)>5 ) 
    {
    echo '<p class="tagbox">'.$L['Show_only_tag'],'</p><div class="tagbox">';
    foreach($arrTags as $strTag)
    {
      echo '<a class="tag',(count($arrTags)>12 ? ' small' : ''),'" href="'.Href('qtr_find.php').'?a=tst&amp;s=',$s,'&amp;y=',date('Y'),'&amp;k1=-1&amp;k2=-1&amp;k3=',$strTag,'">',$strTag,'</a>&nbsp; ';
    }
    echo '</div>',N;
    }
    else
    {
    echo '<p class="tagline">'.$L['Show_only_tag'];
    foreach($arrTags as $strTag)
    {
      echo ' <span class="tagline" title=""><a class="tag" href="'.Href('qtr_find.php').'?a=tst&amp;s=',$s,'&amp;y=',date('Y'),'&amp;k1=-1&amp;k2=-1&amp;k3=',urlencode($strTag),'">',$strTag,'</a></span>';
    }
    echo '</p>',N;
    }
  }
}

// MAP MODULE

if ( $bMap )
{
  echo '<!-- Map module -->',N;
  if ( count($arrExtData)>0 )
  {
    $strMapHelp = '<p class="gmap" style="margin:4px 0 0 0">'.sprintf( $L['map']['items'],count($arrExtData),strtolower(LangS('Topic',$oSEC->items)) ).'</p>';

    if ( $bMapGoogle )
    {
      echo '<table class="hidden" style="margin-top:5px;">',N;
      echo '<tr class="hidden">',N;
      echo '<td class="gmap">',N;
      if ( !$_SESSION[QT]['m_map_hidelist'] )
      {
      echo QTgmapZoomControl($arrExtData);
      echo '<div id="map_canvas" style="width:100%; height:400px;"></div>',N;
      }
      echo $strMapHelp;
      echo '</td>',N;
      echo '</tr>',N;
      echo '</table>',N;
    }

    if ( $bMapSitework )
    {
      if ( !$_SESSION[QT]['m_map_hidelist'] ) include('qtrm_sitework/mapapi.php');
    }

    // Show/Hide

    if ( $_SESSION[QT]['m_map_hidelist'] ) 
    {
    echo '<p style="margin:2px"><a href="',Href($oVIP->selfurl),'?s=',$s,'&amp;showmap">',$L['map']['Show_map'],'</a></p>';
    }
    else
    {
    echo '<p style="margin:2px"><a href="',Href($oVIP->selfurl),'?s=',$s,'&amp;hidemap">',$L['map']['Hide_map'],'</a></p>';
    }

  }
  else
  {
    echo '<p class="gmap">'.$L['map']['E_noposition'].'</p>';
  }
  echo '<!-- Map module end -->',N;
}

// ---------
// HTML END
// ---------

// MAP MODULE

if ( $bMap )
{
  if ( count($arrExtData)>0 ) { include('qtrm_map_load.php'); } else { echo '<script type="text/javascript">function GUnload() { return true; }</script>'; }
}

include('qtr_p_footer.php');