<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registrations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
require_once('bin/qtr_fn_admin.php');
if ( !$oVIP->CanView('V2') ) HtmlPage(11);

$s = -1; QThttpvar('s','int'); if ( $s<0 ) die('Missing section id...');

// ---------
// INITIALISE
// ---------

// Check arguments

$size = strip_tags($_GET['size']);
$intCount = intval($_GET['n']);

if ( empty($size) || $intCount <= $_SESSION[QT]['topics_per_page'] ) $size='all';
if ( strlen($size)>6 || strlen($size)<2 ) die('Invalid argument');
if ( substr($size,0,1)!='p' && substr($size,0,1)!='m' && $size!='all') die('Invalid argument');
if ( substr($size,0,1)=='p' )
{
  $i = intval(substr($size,1));
  if ( empty($i) ) die('Invalid argument');
  if ( ($i-1) > $intCount/$_SESSION[QT]['topics_per_page'] ) die('Invalid argument');
}
if ( substr($size,0,1)=='m' )
{
  if ( $size!='m1' && $size!='m2' && $size!='m5' && $size!='m10' ) die('Invalid argument');
}
if ( $intCount >1000 && $size=='all' ) die('Invalid argument');
if ( $intCount<=1000 && substr($size,0,1)=='m' ) die('Invalid argument');
if ( $intCount>1000 && substr($size,0,1)=='p' ) die('Invalid argument');

// apply page argument

if ( substr($size,0,1)=='p' ) $_GET['page'] = substr($size,1);

// Initialise

$strCSV = '';

include('bin/qtr_fn_sql.php');

$oSEC = new cSection($s);
if ( isset($_SESSION[QT]['lastcolumn']) ) $oSEC->d_last=$_SESSION[QT]['lastcolumn'];

if ( $oSEC->type==1 && ($oVIP->role=='V' || $oVIP->role=='U') )
{
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,$L['R_staff'],$_SESSION[QT]['skin_dir'],0);
}
if ( $oSEC->type==2 && $oVIP->role=='V' )
{
  // exit
  $oVIP->selfname = $L['Section'];
  $oVIP->exitname = ObjTrans('index','i',$_SESSION[QT]['index_name']);
  $oVIP->EndMessage(NULL,Error(11),$_SESSION[QT]['skin_dir'],0);
}

$oVIP->selfurl = 'qtr_topics.php';
$oVIP->selfname = $L['Section'].': '.$oSEC->name;

$strCommand = '';
$numid = '';

$strOrder = $oSEC->d_order; // lastpostdate
if ( $strOrder=='title' ) { $strDirec='ASC'; } else { $strDirec = 'DESC'; }
$intPage = 1;
$intLimit = 0;
$intLen = $_SESSION[QT]['topics_per_page'];
if ( isset($_GET['page']) ) { $intLimit = (intval($_GET['page'])-1)*$intLen; $intPage = intval($_GET['page']); }
if ( isset($_GET['order']) ) $strOrder = $_GET['order'];
if ( isset($_GET['dir']) ) $strDirec = $_GET['dir'];

// apply argument

if ( $size=='all') { $intLimit=0; $intLen=$intCount; }
if ( $size=='m1' ) { $intLimit=0; $intLen=999; }
if ( $size=='m2' ) { $intLimit=1000; $intLen=1000; }
if ( $size=='m5' ) { $intLimit=0; $intLen=4999; }
if ( $size=='m10') { $intLimit=5000; $intLen=5000; }

if ( QTR_LIST_ME && $oVIP->numpost>0)
{
$oDB2 = new cDB($qtr_dbsystem,$qtr_host,$qtr_database,$qtr_user,$qtr_pwd,$qtr_port,$qtr_dsn);
}

// Criteria sql: topics visible for current user ONLY

$strWhere = '';
if ( $oSEC->type==2 && !$oVIP->IsStaff() ) $strWhere .= ' AND (t.firstpostuser='.$oVIP->id.' OR t.type="A")';
if ( $_SESSION[QT]['show_closed']=='0' ) $strWhere.=' AND t.status<>"Z"';
$strOnTop = '';
if ( $_SESSION[QT]['news_on_top']==1 )
{ 
  $strOnTop = 'CASE t.type WHEN "A" THEN "A" ELSE "Z" END as typea,';
}

// --------
// HTML START
// --------

// Last column: can be '0' (moderator requests no-field)
switch($oSEC->d_last)
{
case 'replies': $str=$L['Replys']; break;
case 'views': $str=$L['Views']; break;
case 'status': $str=$L['Status']; break;
case 'wisheddate': $str=$L['Wisheddate']; break;
case 'eventdate': $str=$L['Eventdate']; break;
case 'id': $str='Id'; break;
case 'actorname': $str=$L['Userrole_MA']; break;
case 'notifiedname': $str=$L['Userrole_UN']; break;
case 'tags': $str=$L['Tags']; break;
default: $str=$oSEC->d_last;
}

// ========
$arrFLD = array();
$arrFLD['csvdate'] = new cTableCell('csvdate',$L['Date']);
$arrFLD['csvtime'] = new cTableCell('csvtime',$L['Time']);
$arrFLD['status'] = new cTableCell('status','Status');
if ( $oSEC->numfield!='N' ) $arrFLD['numid'] = new cTableCell('numid',$L['Ref']);
if ( !empty($oSEC->prefix) ) $arrFLD['smile'] = new cTableCell('smile','Ico');
$arrFLD['title'] = new cTableCell('title',$L['Topics']);
$arrFLD['text'] = new cTableCell('text','Text');
$arrFLD['firstpostname'] = new cTableCell('firstpostname',$L['Author']);
$arrFLD['lastpostdate'] = new cTableCell('lastpostdate',$L['Last_message']);
if ( $oSEC->d_last=='none' || empty($oSEC->d_last) || $oSEC->d_last=='N' || $oSEC->d_last=='replies' )
{
$arrFLD['replies'] = new cTableCell('replies',$L['Replys']);
}
else
{
$arrFLD['replies'] = new cTableCell('replies',$L['Replys']);
$arrFLD[$oSEC->d_last] = new cTableCell($oSEC->d_last,$str);
}
$arrFLD['uid'] = new cTableCell('uid','UID');
// ========
foreach($arrFLD as $oFLD) $strCSV .= ToCsv($oFLD->name);
$strCSV = substr($strCSV,0,-1).PHP_EOL;
// ========
$strState = $strOnTop.'t.*,p.title,p.icon,p.textmsg FROM '.TABTOPIC.' t INNER JOIN '.TABPOST.' p ON t.firstpostid=p.id WHERE t.section = '.$oSEC->id.$strWhere;
if ( $strOrder=='title' ) { $strFullOrder='p.title'; } else { $strFullOrder='t.'.$strOrder; }
$oDB->Query( LimitSQL($strState,(empty($strOnTop) ? '' : 'typea ASC, ').$strFullOrder.' '.$strDirec,$intLimit,$intLen,$intCount) );
// ========
$intWhile=0;
while($row=$oDB->Getrow())
{
  $str = implode('',TableRowFormat($arrFLD,$row,true,$oSEC,false,true));
  if ( substr($str,-1,1)==';' ) $str = substr($str,0,-1);
  $strCSV .= $str.PHP_EOL;

  $intWhile++; 
  //odbcbreak
  if ( $intWhile>=$intCount ) break;  
}
// ========

// OUPUT

if ( isset($_GET['debug']) )
{
  echo $strCSV;
  exit;
}

if ( !headers_sent() )
{
  header('Content-Type: text/csv; charset='.QTR_HTML_CHAR);
  header('Content-Disposition: attachment; filename="qtr_'.date('YmdHi').'.csv"');
}

echo $strCSV;