<?php

/**
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package    Q-registrations
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.5 build:20110627
 */

session_start();
require_once('bin/qtr_init.php');
if ( !$oVIP->CanView('U') ) die(Error(11));
$id = -1; QThttpvar('id','int'); if ($id<0) die('Missing parameters');

// --------
// INITIALISE
// --------

include('bin/qt_lib_smtp.php');
include(GetLang().'qtr_reg.php');

$oVIP->selfurl = 'qtr_user_pwd.php';
$oVIP->selfname = $L['Change_password'];
$oVIP->exiturl = Href('qtr_user.php').'?id='.$id;
$oVIP->exitname = '&laquo; '.$L['Profile'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check value
  if ( !QTispassword($_POST['oldpwd']) ) $error=$L['Old_password'].' '.$L['E_invalid'];
  if ( !QTispassword($_POST['newpwd']) ) $error=$L['New_password'].' '.$L['E_invalid'];
  if ( !QTispassword($_POST['conpwd']) ) $error=$L['Confirm_password'].' '.$L['E_invalid'];
  if ( $_POST['oldpwd']==$_POST['newpwd'] ) $error=$L['New_password'].' '.$L['E_invalid'];
  if ( $_POST['conpwd']!=$_POST['newpwd'] ) $error=$L['Confirm_password'].' '.$L['E_invalid'];

  // check old pwd
  if ( empty($error) )
  {
    $oDB->Query('SELECT count(*) as countid FROM '.TABUSER.' WHERE id='.$id.' AND pwd="'.sha1($_POST['oldpwd']).'"');
    $row = $oDB->Getrow();
    if ($row['countid']==0) $error=$L['Old_password'].' '.$L['E_invalid'];
  }

  // execute and exit
  if ( empty($error) )
  {
    $oDB->Query('UPDATE '.TABUSER.' SET pwd="'.sha1($_POST['newpwd']).'" WHERE id='.$id);

    // send parent email (if coppa)
    if ( $_POST['children']!='0' ) {
    if ( $_SESSION[QT]['register_coppa']=='1') {
      $oDB->Query('SELECT parentmail FROM '.TABCHILD.' WHERE id='.$id);
      $row = $oDB->Getrow();
      $strSubject = $_SESSION[QT]['site_name'].' - New password';
      $strMessage = "We inform you that your children has changed his/her password on the board {$_SESSION[QT]['site_name']}.\nLogin: %s\nPassword: %s";
      $strFile = GetLang().'mail_pwd_coppa.php';
      if ( file_exists($strFile) ) include($strFile);
      $strMessage = sprintf($strMessage,$_POST['name'],$_POST['newpwd']);
      QTmail($row['parentmail'],QTconv($strSubject,'-4'),QTconv($strMessage,'-4'),QTE_HTML_CHAR);
    }}

    $oVIP->EndMessage(NULL,$L['S_update'],$_SESSION[QT]['skin_dir'],2);
  }
}

// --------
// HTML START
// --------

include('qtr_p_header.php');

// CHECK ACCESS RIGHT

if ( ( $oVIP->role!='A' ) && ($oVIP->id!=$id) ) die($L['R_user']);

$oDB->Query('SELECT * FROM '.TABUSER.' WHERE id='.$id);
$row = $oDB->Getrow();

  // check id
  if ( !isset($row['id']) ) $oVIP->EndMessage(NULL,'Unknown user (id '.$id.')',$_SESSION[QT]['skin_dir'],2);


echo '
<table class="hidden" cellspacing="0">
<tr class="hidden">
<td class="hidden" style="width:175px"><br />',AsImgBox(AsImg(AsAvatarSrc($row['photo']),'',$row['name']),'picbox','',$row['name']);
if ( $oVIP->id!=$id ) echo '<div class="profile warning"><p class="profile warning">',$L['W_Somebody_else'],'</p></div>';
echo '</td>',PHP_EOL;
echo '<td class="hidden">',PHP_EOL;

$oHtml->Msgbox($oVIP->selfname,array(),array('id'=>'login_header'),array('id'=>'login'));

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.oldpwd.value.length==0) { alert(qtHtmldecode("',$L['Missing'],': ',$L['Old_password'],'")); return false; }
  if (theForm.newpwd.value.length==0) { alert(qtHtmldecode("',$L['Missing'],': ',$L['New_password'],'")); return false; }
  if (theForm.conpwd.value.length==0) { alert(qtHtmldecode("',$L['Missing'],': ',$L['Confirm_password'],'")); return false; }
  return null;
}
-->
</script>
<form method="post" action="',Href(),'" onsubmit="return ValidateForm(this);">
<p style="text-align:right">',$L['Old_password'],'&nbsp;<input type="password" id="oldpwd" name="oldpwd" size="20" maxlength="24" /></p>
<p style="text-align:right">',$L['New_password'],'&nbsp;<input type="password" id="newpwd" name="newpwd" size="20" maxlength="24" /></p>
<p style="text-align:right">',$L['Confirm_password'],'&nbsp;<input type="password" id="conpwd" name="conpwd" size="20" maxlength="24" /></p>
<p style="text-align:right">';
if ( !empty($error) ) echo '<span class="error">',$error,' </span>';
echo '<input type="submit" id="ok" name="ok" value="',$L['Save'],'" />
<input type="hidden" name="id" value="',$id,'" />
<input type="hidden" name="username" value="',$row['name'],'" />
<input type="hidden" name="children" value="',$row['children'],'" /></p>
</form>
<p style="margin:0;text-align:left"><a href="',$oVIP->exiturl,'">',$oVIP->exitname,'</a></p>
';

$oHtml->Msgbox();

echo '
</td>
</tr>
</table>
';

// --------
// HTML END
// --------

$strFooterAddScript = '
<script type="text/javascript">
<!--
document.getElementById("oldpwd").focus();
-->
</script>
';

include('qtr_p_footer.php');