<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QT-register
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
if ( !$oVIP->CanView('U') ) die('Access denied');

// --------
// INITIALISE
// --------

include('bin/qt_lib_smtp.php');
include(Translate('qtr_reg.php'));

$id = -1; QThttpvar('id','int'); if ( $id<0 ) die('Missing user id...');

$oVIP->selfurl = 'qtr_user_rename.php';
$oVIP->selfname = $L['Rename'];
$oVIP->exiturl = 'qtr_user.php?id='.$id;
$oVIP->exitname = '&laquo; '.$L['Profile'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check name
  if ( empty($error) )
  {
    $strName = trim(strip_tags($_POST['title'])); if ( get_magic_quotes_gpc() ) $strName = stripslashes($strName);
    if ( !QTislogin($strName) ) $error = $L['Username'].' '.Error(1);
    if ( empty($error) )
    {
    $oDB->Query('SELECT count(*) as countid FROM '.TABUSER.' WHERE name="'.$strName.'"');
    $row = $oDB->Getrow();
    if ( $row['countid']!=0 ) $error = '['.$strName.'] '.$L['E_already_used'];
    }
  }

  // execute and exit
  if ( empty($error) )
  {
    $oDB->Query('UPDATE '.TABUSER.' SET name="'.$strName.'" WHERE id='.$id);
    $oDB->Query('UPDATE '.TABPOST.' SET username="'.$strName.'" WHERE userid='.$id);
    $oDB->Query('UPDATE '.TABPOST.' SET modifname="'.$strName.'" WHERE modifuser='.$id);
    $oDB->Query('UPDATE '.TABTOPIC.' SET firstpostname="'.$strName.'" WHERE firstpostuser='.$id);
    $oDB->Query('UPDATE '.TABTOPIC.' SET lastpostname="'.$strName.'" WHERE lastpostuser='.$id);
    $oDB->Query('UPDATE '.TABDATA.' SET fieldusername="'.$strName.'" WHERE fielduserid='.$id);
    $oVIP->EndMessage(NULL,$L['S_update'],$_SESSION[QT]['skin_dir'],2);
  }
}

$oDB->Query('SELECT name,photo FROM '.TABUSER.' WHERE id='.$id);
$row = $oDB->Getrow();
$row['name'] = QTconv($row['name'],'5');
  
// --------
// HTML START
// --------

$strHeadScript = '
<script type="text/javascript" src="bin/qt_jquery.js"></script>
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("'.$L['Missing'].': '.$L['Username'].'")); return false; }
  return null;
}
$(function() {
  $("#title").keyup(function() {
    if ($("#title").val().length>1)
    {
      $.post("qtr_j_exists.php",
      {f:"name",v:$("#title").val(),e1:"'.$L['E_min_4_char'].'",e2:"'.$L['E_already_used'].'"},
      function(data) { if ( data.length>0 ) document.getElementById("title_err").innerHTML=data; });
    }
    else
    {
      document.getElementById("title_err").innerHTML="";
    }
  });
});
-->
</script>
';
include('qtr_p_header.php');

echo '
<table class="hidden" cellspacing="0" summary="Change username">
<tr class="hidden">
<td class="hidden" style="width:175px"><br />',AsImgBox(AsImg(AsAvatarSrc($row['photo']),'',$row['name']),'picbox','',$row['name']);
if ( $oVIP->id!=$id ) echo '<div class="profile warning"><p class="profile warning">',$L['W_Somebody_else'],'</p></div>';
echo '</td><td class="hidden">
';

HtmlMsg(0,'400px','',$oVIP->selfname);

echo '<form method="post" action="',Href(),'" onsubmit="return ValidateForm(this);">';
echo '<input type="hidden" name="id" value="',$id,'"/>';
echo '<h2>',$row['name'],'</h2>';
if ( !empty($error) ) echo '<p id="infomessage" class="error">',$error,'</p>';
echo '<p>',$L['Choose_name'],'</p>';
echo '<p><input type="text" id="title" name="title" size="20" maxlength="32" onfocus="document.getElementById(\'title_err\').innerHTML=\'\';"/> <input type="submit" name="ok" value="',$L['Save'],'"/> <span id="title_err" class="small error"></span></p>';
echo '</form>';
echo '<a href="',Href($oVIP->exiturl),'">',$oVIP->exitname,'</a>';
echo '</div>
';

HtmlMsg(1);

echo '
</td>
</tr>
</table>
';

// --------
// HTML END
// --------

include('qtr_p_footer.php');