<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    Q-registerations
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.5 build:20110627
*/

session_start();
require_once('bin/qtr_init.php');
if ( !$oVIP->CanView('U',true) ) die(Error(11));

// INITIALISE

$id = -1; QThttpvar('id','int'); if ( $id<0 ) die('Missing user id...');

if ( $oVIP->id!=$id && !$oVIP->IsStaff() ) die(Error(11));

include(Translate('qtr_reg.php'));

$oVIP->selfurl = 'qtr_user_sign.php';
$oVIP->selfname = $L['Change_signature'];
$oVIP->exiturl = 'qtr_user.php?id='.$id;
$oVIP->exitname = $L['Profile'];

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check values
  $str = trim($_POST['text']); if ( get_magic_quotes_gpc() ) $str = stripslashes($str);
  $str = substr( QTconv($str,'3',QTR_CONVERT_AMP),0,255 );

  // update domain
  if ( empty($error) )
  {
    $oDB->Query('UPDATE '.TABUSER.' SET signature="'.addslashes($str).'" WHERE id='.$id);
    // exit
    $oVIP->exiturl = 'qtr_user.php?id='.$id;
    $oVIP->EndMessage(NULL,$L['S_update'],$_SESSION[QT]['skin_dir'],2);
  }
}

// --------
// HTML START
// --------

if ( $_SESSION[QT]['bbc']=='1' )
{
  $oHtml->scripts[]='<script type="text/javascript" src="bin/qtr_bbc.js"></script>';
  $oHtml->links[]='<link rel="stylesheet" type="text/css" href="bin/css/qtr_bbc.css" title="cssmain" />';
}

include('qtr_p_header.php');

$oDB->Query('SELECT signature,name,photo,role FROM '.TABUSER.' WHERE id='.$id);
$row = $oDB->Getrow();

  // staff cannot edit other staff
  if ( $row['role']=='M' && $oVIP->role=='M' && $oVIP->id!=$id ) die(Error(13));

if ( !is_string($row['signature']) ) $row['signature']='';
$row['name'] = QTconv($row['name'],'5');

$strSign = QTbbc($row['signature']);
if ( empty($strSign) ) $strSign=S;

echo '
<table class="hidden" cellspacing="0">
<colgroup span="2"><col width="175"></col><col></col></colgroup>
<tr class="hidden">
<td class="hidden"><br/>',AsImgBox(AsImg( (empty($row['photo']) ? '' : QTR_DIR_PIC.$row['photo']),'',$row['name']),'picbox','',$row['name']);
if ( $_SESSION[QT]['editing'] && $oVIP->id!=$id ) echo '<div class="profile warning"><p class="profile warning">',$L['W_Somebody_else'],'</p></div>';
echo '</td>
<td class="hidden">
';

// SIGNATURE

echo '
<h2>',$L['Signature'],'</h2>
<table class="data_o" cellspacing="0">
<tr class="data_o">
<td class="colct">',$strSign,'</td>
</tr>
</table>
<p>',$L['H_no_signature'],'</p>
';

// NEW SIGNATURE

echo '
<h2>',$oVIP->selfname,'</h2>
<form method="post" action="',Href(),'">
<table class="data_o" cellspacing="0">
<tr class="data_o">
<td class="colct">
';
    echo '<table class="hidden" cellspacing="0">',N;
    if ( $_SESSION[QT]['bbc']=='1' )
    {
    echo '<tr class="hidden">',N;
    echo '<td style="height:22px"><ul class="bbc">',N;
    $intBbc=3; include('qtr_form_button.php');
    echo '</ul></td>',N;
    echo '</tr>',N;
    }
    echo '<tr class="hidden">',N;
    echo '<td class="hidden">',N;
    echo '<a name="textarea" id="textarea"></a><textarea id="text" name="text" rows="5" cols="75">',$row['signature'],'</textarea>',N;
    echo '</td>',N;
    echo '</tr>',N;
    echo '</table>',N;

echo '</td>
</tr>
<tr class="data_o">
<td class="colct">
<input type="hidden" name="id" value="',$id,'"/>
<input type="submit" name="ok" value="',$L['Save'],'"/>',( !empty($error) ? ' <span class="error">'.$error.'</span>' : ''),'</td>
</tr>
</table>
</form>
<p>&laquo;&nbsp;<a href="',Href($oVIP->exiturl),'">',$L['Profile'],'</a></p>
';

echo '
</td>
</tr>
</table>
';

// HTML END

include('qtr_p_footer.php');

?>